/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
        
        if(!oComponent instanceof Component){
            console.error("oComponent is not a Component instance. onUpdateComponent(...) [info.html]"); return 1;
        }
        
        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        
        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Set gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cicle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set save last value
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        for(var i=0; i<aIcons.length; ++i){
            var oIcon = aIcons[i];
            var $wrapper = $("<div class='icon'></div>");
            var $canvas = $("<canvas></canvas>");
            var $status = $("<span></span>");
            var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");
            
            //Jump if state is empty
            if(oIcon.status.toString().length < 1){
                continue;
            }
            
            //Default image loading
            var imgHeight = parseInt(img.height,10);                        // Image height
            var imgWidth = parseInt(img.width,10);                          // Image width
            var stretchScale = 0.5;
            var drawHeight = imgHeight * stretchScale;
            var drawWidth = imgWidth * stretchScale; 
            var canvas = $canvas[0];
            var cont = canvas.getContext("2d");
            
            $wrapper.attr("height",64);
            $wrapper.attr("width",64);
            $canvas.attr("height",64);
            $canvas.attr("width",64);
            
            //Height - Width streched
            cont.drawImage(img,(oIcon.position.x * stretchScale),(oIcon.position.y * stretchScale),drawWidth,drawHeight);
            
            var imageData = cont.getImageData(0,0,64,64);
            
            //Color image
            if(oIcon.enableColors){
                //Color image
                for(var j=0; j<imageData.data.length; j+=4){
                    imageData.data[j+0] = oIcon.color.R;
                    imageData.data[j+1] = oIcon.color.G;
                    imageData.data[j+2] = oIcon.color.B;
                    imageData.data[j+3] = imageData.data[j+3];
                }
            }
            
            cont.putImageData(imageData,0,0);
            
            $status.text(oIcon.status);
            
            $wrapper.append($canvas);
            $wrapper.append($status);
            $Elem.append($wrapper);
        }
        if($Elem.find(".icon").length < 1){
            var $div = $("<div></div>");
            $div.css("height","64px").css("width","100%").text(_D("Any icon"));
            $Elem.append($div);
        }
        
        //Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX - functional block
        $Elem = $componentProperties.find("[eve-manager-id='knx/functional-block'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            
            if($currElem.val() == oComponent.getParamVal("knx/functional-block")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));



        //Set Vimar By Me
        $.ajax({
            url: "./declarations/vimar/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                var $dropDown = $("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                
                //Parsing Vimar By Me Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("combo") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                
                //Select currently
                $dropDown.find("[value='"+ oComponent.getParamVal("vimar/device-pid") +"']").prop("selected",true);
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        //Set Combo Values
        $Elem = $componentProperties.find("[eve-manager-id='values']");
        aValue = oComponent.getParamVal("values");
        $Elem.find("input[type='text']").remove();
        for(var i=0; i<aValue.length; ++i){
            
            if(aValue[i].value == "" && aValue[i].description == ""){
                continue;
            }
            
            var $line = getComboHtmlLine();
            $line.find(".value").val(aValue[i].value);
            $line.find(".description").val(aValue[i].description);
            
            //Append
            $Elem.find("form").append($line);
        }
        
        if($Elem.find("input[type='text']").length < 1){
            $Elem.find("form").append(getComboHtmlLine());
        }
        
        
    };
}
catch(err){
    console.error(err);
}
