/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);

        oComponent.addParamVal("updateonchange",true);
        
        //Set default values
        oComponent.addParamVal("name", _D("RGB Light")+" "+oComponent.UId);
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oIcon_status_1 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
                var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.RGBLight.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i1=model["instance"].skin.IconsPan[0].ComponentsInfo.RGBLight.defaultIcons[1];
        $.extend(true, oIcon_status_1, {
            status: 1,
            position:{ x: -i1.position.x*iconw, y: -i1.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }
        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);
        aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		,{id:3, label:"Hidden"} 
        	]);
        
        //Knx
        oComponent.addParamVal("knx/red/write-address","//");
        oComponent.addParamVal("knx/red/feedback-address","//");
        oComponent.addParamVal("knx/green/write-address","//");
        oComponent.addParamVal("knx/green/feedback-address","//");
        oComponent.addParamVal("knx/blue/write-address","//");
        oComponent.addParamVal("knx/blue/feedback-address","//");
        oComponent.addParamVal("knx/virtual-feedback",false);
        oComponent.addParamVal("knx/read-init",true);

        // HUE
        oComponent.addParamVal("hue/id","1");

        //Vimar
        oComponent.addParamVal("vimar/device-pid","none");
        oComponent.addParamVal("vimar/device-fid","none");
        
        oComponent.addParamVal("vimar/red/group-address","");
        oComponent.addParamVal("vimar/red/physical-address","");
        
        oComponent.addParamVal("vimar/green/group-address","");
        oComponent.addParamVal("vimar/green/physical-address","");
        
        oComponent.addParamVal("vimar/blue/group-address","");
        oComponent.addParamVal("vimar/blue/physical-address","");

        oComponent.addParamVal("vimar/enable-sfbk",false);
        oComponent.addParamVal("vimar/sfbk","//");

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");


    };
}
catch(err){
    console.error(err);
}
