/** componentEditor class (extends Window class)
 *
 * @class componentEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

//TODO Optimize current class hiding HTML list items

function readOnlySet(elm){
    var $this = $(elm);
    var strParam = $this.attr("eve-manager-id");
    var strValue = $this.find(":selected").val();
    var strLabel = $this.find(":selected").text();

    console.log($this.data("componentMap"));
    $this.data("componentMap").readOnlyComponent=strValue;

};
function componentEditor(oWindow){
	
	var self = this;
	
	/**
	 * Called once when we open Eve Manager
	 */
	var init = function(){
        console.log("%cWindow - componentEditor class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            title: _D("Editor"),

            maxHeight: 500,
            width: 550,
            minWidth: 560,
            resizable:false,
            autoOpen: false,
            modal: true,
            close: m_oWindow.hide,
            create: function(e,ui){
                $(this).find(".actions button").button();
            }
        });

        var config = {
            '.chosen-container'        : { width: "220px"  },
            '.chosen-select'           : {},
            '.chosen-select-deselect'  : {allow_single_deselect:true},
            '.chosen-select-no-single' : {disable_search_threshold:10},
            '.chosen-select-no-results': {no_results_text:'Oops, nothing found!'},
            '.chosen-select-width'     : {width:"95%"}
        };

        for (var selector in config) {
            m_$element.find(".disableIconComponentValue").chosen(config[selector]);
        };
        m_$element.find(".disableIconComponentValue").trigger("chosen:updated");



        for (var selector in config) {
            m_$element.find(".hideIconComponentValue").chosen(config[selector]);
        };
        m_$element.find(".hideIconComponentValue").trigger("chosen:updated");


        //On choose icon
        m_$element.on("click",".icon",self._editIcon);
        
        //On Submit
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".actions [type='reset']",function(e){
            m_oWindow.hide();
        });
        
        //On remove
        m_$element.on("click",".actions .remove",self._removeComponent);

        //On change scale
        m_$element.on("change",".scaleFactor-picker",function(){
            m_$element.find(".scaleFactor").val(parseInt(this.value,10) * 100);
        });

        m_$element.find(".scaleFactorWidth").val(1);
        m_$element.find(".scaleFactorHeight").val(1);
/*
        //On change scale Width
        m_$element.on("change",".scaleFactor-picker",function(){
            m_$element.find(".scaleFactorWidth").val(this.value);
        });

        //On change scale Height
        m_$element.on("change",".scaleFactor-picker",function(){
            m_$element.find(".scaleFactorHeight").val(this.value);
        });
*/



    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element = oWindow;
    
    /** Additional parameters
     * @type {variable}
     */
    var m_oParam = undefined;

    function FillDropDown(
        divPlace,data,value,
        divLogic,logicValue
    ) {
        var self = this;
        //console.log(value);
        var $select=divPlace;

        var componentType = data.type;

        //Get all created components
        var aComponent = application.getComponentsByType( componentType );

        $select.attr("eve-manager-id",data.uid);
        $select.data("componentType",data);
        $select.empty();
        $select.append($("<option " + (value == "never" ? "selected" : "") + " value='never'>Never</option>"));
        $select.append($("<option " + (value == "always" ? "selected" : "") + " value='always'>Always</option>"));

        var alreadyAdded=[];
        for(var j=0; j<aComponent.length; ++j){
            var oNode = aComponent[j];
            var oParent = oNode.getParent();
            var oComponentExt = oNode.getData();
            var label = oComponentExt.getParamVal("name");
            if(oParent.getData() instanceof Component){
                label = oParent.getData().getParamVal("name") +" - "+ label;
            }
            var $option;
            $option = $("<option value='"+oComponentExt.UId+"'>"+ label +"</option>");

            if (oComponentExt.UId==value)
            {
                $option = $("<option selected  value='"+oComponentExt.UId+"'>"+ label +"</option>");
                $select.val(value);
            }

            $option.val(oComponentExt.UId);
            $option.data("eveManagerNode",oComponentExt);
            $select.append($option);
        }

        var config = {
            '.chosen-container'        : { width: "220px"  },
            '.chosen-select'           : {},
            '.chosen-select-deselect'  : {allow_single_deselect:true},
            '.chosen-select-no-single' : {disable_search_threshold:10},
            '.chosen-select-no-results': {no_results_text:'Oops, nothing found!'},
            '.chosen-select-width'     : {width:"95%"}
        };

        for (var selector in config) {
            $select.chosen(config[selector]);
        };
        $select.trigger("chosen:updated");


        $select=divLogic;
        $select.empty();
        $select.append($("<option " + (logicValue == "0" ? "selected" : "") + " value='0'>OFF</option>"));
        $select.append($("<option " + (logicValue == "1" ? "selected" : "") + " value='1'>ON</option>"));

        for (var selector in config) {
            $select.chosen(config[selector]);
        };
        $select.trigger("chosen:updated");

    //    readOnlySet($select);
    };

    /** Show icon editor window
	 */
	this.show = function(oParam){
	    //Set parameters
	    m_oParam = oParam;
	    
	    var oNode = m_oWindow.getActiveNode();
	    var oData = oNode.getData();
	    
	    //Declare variables
	    var name;
	    var aIcons = new Array();
	    var oIcon;
	    var scaleFactor;
        var scaleFactorWidth;
        var scaleFactorHeight;

        var ui_disableCircleIcon;
        var ui_readOnly;

        //UIComponent
        if(oData instanceof UIComponent){
            name = oData.getParamVal("name");
            oIcon = oData.getParamVal("icon");
            aIcons.push(oData.getParamVal("icon"));


            $("#componentEditor").find("li").show();
            $("#componentEditor").find("li").filter(":not(.eve-manager-classic)").hide();


            //Check component reference
            if(oData.referenceUId != undefined){
                var oRefNode = application.getComponentByUid(oData.referenceUId);
                var oRefComponent = oRefNode.getData();
                var path = oRefComponent.getParamVal("name") +" (UID: "+ oRefComponent.UId +")";
                var oParent = oRefNode.getParent();

                while(!oParent.isRoot()){
                    //console.error(oParent);
                    path = oParent.getData().getParamVal("name") +" > "+ path;
                    oParent = oParent.getParent();
                }

                m_$element.find(".path").text(path);

            }
        }
        //Map
        else if(oData instanceof Map){
            name = oData.name;
            oIcon = oData.icon;
            console.log(oIcon);
            aIcons.push(oData.icon);
            
            //Check parameter
            if(m_oParam == undefined || !m_oParam.getData() instanceof UIComponent){
                console.error("Additional parameter is not a UIComponent instance");
                alert("Error: additional parameter is not a UIComponent instance");
                return;
            }
            
            var oUIComponent = m_oParam.getData();
            var aMaps = oUIComponent.getMaps().children;
            
            //Disable remove if UIComponents has single map
            if(aMaps.length < 2){
                m_$element.find(".actions .remove").hide().prop("disabled",true);
            }
            else
            {
                m_$element.find(".actions .remove").show().prop("disabled",false);
            }
            $("#componentEditor").find("li").show();
            $("#componentEditor").find("li").filter(":not(.eve-manager-mapTab)").hide();

            //Hide fields
            //m_$element.find(".scaleFactor").hide().prev().hide().prev().hide();
    /*        m_$element.find(".scaleFactor").parent().hide();
            m_$element.find(".scaleFactorWidth").parent().hide();
            m_$element.find(".scaleFactorHeight").parent().hide();
            m_$element.find(".view-mode-list").parent().hide();
            m_$element.find(".view-mode-list-2").parent().hide();
            m_$element.find(".view-mode-list-3").parent().hide();
            m_$element.find(".view-mode-list-4").parent().hide();
            m_$element.find(".view-mode-list-5").parent().hide();
            m_$element.find(".disableCircleIcon").parent().hide();
            m_$element.find(".path").hide();
     */
          //  m_$element.find(":not(.eve-manager-mapTab)").hide();
          //  m_$element.find(".eve-manager-mapTab").show();




        }
        //MapComponent
        else if(oData instanceof MapComponent){
            name = oData.name;
            scaleFactor = oData.scaleFactor;
            scaleFactorWidth = oData.scaleFactorWidth;
            scaleFactorHeight = oData.scaleFactorHeight;
            ui_disableCircleIcon=oData.uiDisableCircle;
            ui_readOnly=oData.uiReadOnly;

            m_$element.find(".view-mode-list").parent().show();
       /*     m_$element.find(".view-mode-list-2").parent().show();
            m_$element.find(".view-mode-list-3").parent().show();
            m_$element.find(".view-mode-list-4").parent().show();
            m_$element.find(".view-mode-list-5").parent().show();
*/
            m_$element.find(".view-mode-list-2").parent().hide();
            m_$element.find(".view-mode-list-3").parent().hide();
            m_$element.find(".view-mode-list-4").parent().hide();
            m_$element.find(".view-mode-list-5").parent().hide();
            aIcons = oData.icons;



            $("#componentEditor").find("li").show();
            $("#componentEditor").find("li").filter(":not(.eve-manager-mapComponent)").hide();


            if (!oData.iconChanged)
            {
                var oComponent = oData.getReference().getData();
                aIcons = oComponent.getParamVal("icons"); // prendo le icone dal componente originale

            }

            oIcon = aIcons[0];
            //console.error(oData.icons);

            //m_$element.find(".icon").hide().prev().hide();
            
            m_$element.find(".scaleFactor").val(oData.scaleFactor * 100);

            m_$element.find(".scaleFactor-picker [value='"+ oData.scaleFactor +"']").prop("selected",true);

            //alert(oData.scaleFactorWidth);
            m_$element.find(".scaleFactorWidth").val(oData.scaleFactorWidth);
            m_$element.find(".scaleFactorHeight").val(oData.scaleFactorHeight);

            m_$element.find(".readOnly").prop("checked",(ui_readOnly != undefined)?ui_readOnly:false);
            m_$element.find(".disableCircleIcon").prop("checked",(ui_disableCircleIcon != undefined)?ui_disableCircleIcon:false);

            FillDropDown  (
                m_$element.find(".hideIconComponent"),{type:"switch"},oData.hideIconComponent,
                m_$element.find(".hideIconComponentValue"),oData.hideIconComponentValue
            );
            //m_$element.find(".hideIconComponentValue").val(oData.hideIconComponentValue);

            FillDropDown  (
                m_$element.find(".disableIconComponent"),{type:"switch"},oData.disableIconComponent,
                m_$element.find(".disableIconComponentValue"),oData.disableIconComponentValue
            );
            //m_$element.find(".disableIconComponentValue").val(oData.disableIconComponentValue);

            //Fill view mode list
            var oRefNode = oData.getReference();
            var oRefComponent = oRefNode.getData();
            var aModeList = oRefComponent.getParamVal("viewmodelist");
            console.log(aModeList);
            //var $modeList = m_$element.find(".view-mode-list");
            var $modeList = m_$element.find(".view-mode-list, .view-mode-list-2, .view-mode-list-3, .view-mode-list-4, .view-mode-list-5");
            console.log($modeList);
            $modeList.empty();
            for(var i=0; i<aModeList.length; ++i){
                $modeList.append("<option value='"+aModeList[i].id+"' dictionary='"+ aModeList[i].label +"'>"+ _D(aModeList[i].label) +"</option>");
            }

            //console.log(oData);
            //Select view mode
            var $modeList_level1 = m_$element.find(".view-mode-list");
/*
            var $modeList_level2 = m_$element.find(".view-mode-list-2");
            var $modeList_level3 = m_$element.find(".view-mode-list-3");
            var $modeList_level4 = m_$element.find(".view-mode-list-4");
            var $modeList_level5 = m_$element.find(".view-mode-list-5");
*/

            //$modeList.find("[value='"+ oData.viewmode +"']").prop("selected",true);
            $modeList_level1.find("[value='"+ oData.viewmode +"']").prop("selected",true);
         /*   $modeList_level2.find("[value='"+ oData.viewmode2 +"']").prop("selected",true);
            $modeList_level3.find("[value='"+ oData.viewmode3 +"']").prop("selected",true);
            $modeList_level4.find("[value='"+ oData.viewmode4 +"']").prop("selected",true);
            $modeList_level5.find("[value='"+ oData.viewmode5 +"']").prop("selected",true);
*/


            //m_$element.find(".scaleFactor-picker [value='"+ oData.scaleFactor +"']").prop("selected",true);
            var path = oRefComponent.getParamVal("name") +" (UID: "+ oRefComponent.UId +")";
            var oParent = oRefNode.getParent();

            while(!oParent.isRoot()){
                //console.error(oParent);
                path = oParent.getData().getParamVal("name") +" > "+ path;
                oParent = oParent.getParent();
            }

            //oRefNode.encodeJSON();

            m_$element.find(".path").text(path);

            //Set scaleFactor
            if(scaleFactor != undefined){
                m_$element.find(".scaleFactor").val(oData.scaleFactor * 100);
            }
            else{
                //m_$element.find(".scaleFactor").hide().prev().hide();
                m_$element.find(".scaleFactor").parent().hide();

            }

            if(scaleFactorWidth != undefined){
                m_$element.find(".scaleFactorWidth").val(oData.scaleFactorWidth);
            }
            else{
                //m_$element.find(".scaleFactorWidth").hide().prev().hide();
                m_$element.find(".scaleFactorWidth").parent().hide();

            }

            if(scaleFactorHeight != undefined){
                m_$element.find(".scaleFactorHeight").val(oData.scaleFactorHeight);
            }
            else{
                //m_$element.find(".scaleFactorHeight").hide().prev().hide();
                m_$element.find(".scaleFactorHeight").parent().hide();
            }



            if(ui_disableCircleIcon != undefined){

                m_$element.find(".disableCircleIcon").val(name);
            }
            else{
                m_$element.find(".disableCircleIcon").val(false);
            }

            m_$element.find(".gotoComponent").click(function(){
                try{
                    $("#tabs").tabs( {active: 1} );
                    //eveManager.setSelectComponent(ddd);

                    var comp=m_oWindow.getActiveNode();
                    console.log(comp);
                    var ccc=comp.getData();
                    console.log(ccc);
                    var ddd=ccc.getReference();
                    console.log(ddd);
                    application.selectComponent(ddd);
                    //presenter.selectComponent(ddd);
                    m_oWindow.hide();
                }
                catch (e){};

            });



        }
        

        
        //Set name
        if(name != undefined){
            m_$element.find(".name").val(name);
        }
        else{
            m_$element.find(".name").hide().prev().hide();
        }
        

        //Set icon
        if(aIcons != undefined){
            var $icon = m_$element.find(".icon");
            var $li = $icon.parents("li");

            for(var i=0; i<aIcons.length; ++i){
                if(i>0){
                    var $cloned = $li.clone(true,true);
                    $li.after($cloned);
                    $li = $cloned;
                    $icon = $li.find(".icon");
                }

                //var $icon = m_$element.find(".icon");
                var $canvas = $("<canvas></canvas>");
                aIcons[i].srcId="app/resource/0";
                var oPan = application.ResoucesManager.getIconsPanById(aIcons[i].srcId);
                var img = document.getElementById(aIcons[i].srcId);
                //var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");

                //Default image loading
                var imgHeight = parseInt(oPan["params"]["imgHeight"],10);                        // Image height
                var imgWidth = parseInt(oPan["params"]["imgWidth"],10);                          // Image width
                var stretchScale = 0.5;
                var drawHeight = imgHeight * stretchScale;
                var drawWidth = imgWidth * stretchScale;
                var canvas = $canvas[0];
                var cont = canvas.getContext("2d");

                $canvas.attr("height", oPan["params"]["iconsHeight"] * stretchScale);
                $canvas.attr("width", oPan["params"]["iconsWidth"] * stretchScale);

                //Height - Width streched
                cont.drawImage(img,(aIcons[i].position.x * stretchScale),(aIcons[i].position.y * stretchScale),drawWidth,drawHeight);

                //var imageData = cont.getImageData(0,0,drawWidth,drawHeight);
                var imageData = cont.getImageData(0,0,64,64);

                //Color image
                if(aIcons[i].enableColors){
                    //Color image
                    for(var j=0; j<imageData.data.length; j+=4){
                        imageData.data[j+0] = aIcons[i].color.R;
                        imageData.data[j+1] = aIcons[i].color.G;
                        imageData.data[j+2] = aIcons[i].color.B;
                        imageData.data[j+3] = imageData.data[j+3];
                    }
                }

                cont.putImageData(imageData,0,0);

                //Append Icon
                $icon.html($canvas);
                $icon.data({ eveManagerIcon: aIcons[i]});
            }
        }
        else{
            m_$element.find(".icon").hide().prev().hide();
        }
	    
	    m_$element.dialog("open");
	    
        m_$element.find(".name")[0].select();
	};
	
	/** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    //Reset parameters
        m_oParam = undefined;

        var $icons = m_$element.find(".icon");

        while($icons.length > 1){
            $($icons[0]).parents("li").remove();
            $icons = m_$element.find(".icon");
        }



	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
    /** Interactions methods */
    
    /** Chose icon 
     * 
     */
    this._editIcon = function(e){

        /*var oIcon = $(this).data("eveManagerIcon");

        //Open window editor
        presenter.getWindow("iconEditor").show(oNode,{});
        return;*/
        var oNode = m_oWindow.getActiveNode();
        var oIcon = $(this).data("eveManagerIcon");

        self._submit();
        
        //Call external window hide method (close current window)
        m_oWindow.hide();
        
        //Open window editor
        presenter.getWindow("iconEditor").show(oNode,{ "iconstatus": oIcon.status });
    };
    
    /** Remove component
     * 
     */
    this._removeComponent = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData = oNode.getData();
        
        //UIComponent
        if(oData instanceof UIComponent){
            application.removeUIComponent(oNode);
        }
        //Map
        else if(oData instanceof Map){
            
            //Check parameter
            if(m_oParam == undefined || !m_oParam.getData() instanceof UIComponent){
                console.error("Additional parameter is not a UIComponent instance");
                alert("Error: additional parameter is not a UIComponent instance");
                return;
            }
            
            application.removeMapFrom(oNode,m_oParam);
        }
        //MapComponent
        else if(oData instanceof MapComponent){
            //Check parameter
            if(m_oParam == undefined || !m_oParam.getData() instanceof Map){
                console.error("Additional parameter is not a Map instance");
                alert("Error: additional parameter is not a Map instance");
                return;
            }
            
            application.removeMapComponentFrom(oNode,m_oParam);
        }
        
        //Call external window hide method
        m_$element.dialog("close");
    };
    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData = oNode.getData();
        
        //oUIComponent icon editor operations
        if(oData instanceof UIComponent){
            var oUIComponent = oData;
            var newName = m_$element.find(".name").val();
            //var oIcon = oData.getParamVal("icon");
            
            //Set model and view
            $.publish("/model/uicomponents/"+ oUIComponent.id +"/update/parameter",[oUIComponent,"name",newName]);
            $.publish("/view/uicomponents/"+ oUIComponent.id +"/refresh/parameter",[oUIComponent,"name"]);
            
            //Re-select component
            //application.selectUIComponent(oNode);
        }
        //Map
        else if(oData instanceof Map){
            var oMap = oData;
            var newName = m_$element.find(".name").val();
            
            //Set model and view
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"name",newName]);
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"name"]);
        }
        //MapComponent
        else if(oData instanceof MapComponent){

            var oMapComponent = oData;
            var newName = m_$element.find(".name").val();
            var newScaleFactor = parseInt( m_$element.find(".scaleFactor").val() ,10) / 100;
            var newScaleFactorWidth = m_$element.find(".scaleFactorWidth").val();
            var newScaleFactorHeight = m_$element.find(".scaleFactorHeight").val();
            var viewMode = parseInt( m_$element.find(".view-mode-list option:selected").val() ,10);
          /*  var viewMode2 = parseInt( m_$element.find(".view-mode-list-2 option:selected").val() ,10);
            var viewMode3 = parseInt( m_$element.find(".view-mode-list-3 option:selected").val() ,10);
            var viewMode4 = parseInt( m_$element.find(".view-mode-list-4 option:selected").val() ,10);
            var viewMode5 = parseInt( m_$element.find(".view-mode-list-5 option:selected").val() ,10);
*/
            var uiReadOnly = m_$element.find(".readOnly").prop("checked");
            var uiDisableCircle = m_$element.find(".disableCircleIcon").prop("checked");

            var hideIconComponent = m_$element.find(".hideIconComponent").val();
            var hideIconComponentValue = m_$element.find(".hideIconComponentValue").val();
            var disableIconComponent = m_$element.find(".disableIconComponent").val();
            var disableIconComponentValue = m_$element.find(".disableIconComponentValue").val();
            //var readOnlyComponent = m_$element.find(".readOnlyComponent").val();
            //var viewOnlyComponent = m_$element.find(".viewOnlyComponent").val();
            //var readOnlyComponentValue = m_$element.find(".readOnlyComponentValue").val();
            //var viewOnlyComponentValue = m_$element.find(".viewOnlyComponentValue").val();
            //console.log(readOnlyComponent);
            //console.log(viewOnlyComponent);
            //console.log(readOnlyComponentValue);
            //console.log(viewOnlyComponentValue);

            //Save new scale factor globally
            //var appPreferences = presenter.preferences.getParameter("preferences");
            //var appPreferences = application.getConfigParam("preferences");

            //appPreferences["interface"]["iconsScaleFactor"] = parseFloat( newScaleFactor );
            //presenter.preferences.setParameter("preferences",appPreferences);

            presenter.preferences.setInterfacePreferences("iconsScaleFactor",parseFloat( newScaleFactor ));

            //var oDefaultParam = {
              //  name: oComponentNode.getData().getParamVal("name"),
              //  scaleFactor: preferences.interface.iconsScaleFactor
            //uiReadOnly
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"uiDisableCircle",uiDisableCircle]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"uiDisableCircle"]);

            //uiReadOnly
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"uiReadOnly",uiReadOnly]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"uiReadOnly"]);

            //Name
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"name",newName]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"name"]);
            
            //Scale factor
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"scaleFactor",newScaleFactor]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"scaleFactor"]);

            //Scale factor Width
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"scaleFactorWidth",newScaleFactorWidth]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"scaleFactorWidth"]);

            //Scale factor Height
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"scaleFactorHeight",newScaleFactorHeight]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"scaleFactorHeight"]);

            //View mode
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"viewmode",viewMode]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"viewmode"]);
/*
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"viewmode2",viewMode2]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"viewmode2"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"viewmode3",viewMode3]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"viewmode3"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"viewmode4",viewMode4]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"viewmode4"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"viewmode5",viewMode5]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"viewmode5"]);
  */
            // View amd disable opetions....
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"hideIconComponent",hideIconComponent]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"hideIconComponent"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"hideIconComponentValue",hideIconComponentValue]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"hideIconComponentValue"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"disableIconComponent",disableIconComponent]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"disableIconComponent"]);

            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"disableIconComponentValue",disableIconComponentValue]);
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"disableIconComponentValue"]);

        }
        
        //Call external window hide method
        m_oWindow.hide();
    };
}