/** Eve Manager publish/subscribe pattern (functions definition)
 *
 * @namespace PubSub
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 */
"use strict";

var PubSub = {
    Model:{
        Update:{
            User: {
                //Update user parameter
                Parameter: function(e,oUser,key,param){
                    console.debug(e.type);

                    //var oldValue = oUser[key];

                    oUser[key] = param;

                    /*switch(key){
                        case "canvas":
                            //Check map icons position


                            console.error(oldValue);
                            console.error(oUser.UI);
                            break;
                    }*/
                }
            },
            Gateway:{
                //Update gateway name
                Name: function(e,oGateway,strName){
                    console.debug(e.type);
                    oGateway.setName(strName);                 
                },
                //Update gateway protocol
                Protocol: function(e,oGateway,strProtocol){
                    console.debug(e.type);
                    oGateway.setProtocol(strProtocol);
                },
                //Update gateway parameter
                Parameter: function(e,oGateway,key,param){
                    console.debug(e.type);
                    oGateway.setParamVal(key,param);
                }
            },
            Component:{
                Parameter: function(e,oComponent,key,value){
//                    console.log(e.type);


                    oComponent.setParamVal(key,value);


                    //Update combo description
                    if(key == "values"){



                        //Check is combo
                        if (oComponent.getType()== "combo")
                        {
                      /*      var oDescriptor = oComponent.getDescriptor();
                            if(oDescriptor.isEditable()){

                                //Reset descriptions
                                oDescriptor.resetDescriptions();

                                console.log("---------->>>>>>>>adding descriptions");
                                for(var i=0; i<value.length; ++i)
                                {
                                    if (value[i].value!="")
                                    {
                                        console.log(value[i].value+" "+value[i].description);
                                        oDescriptor.addDescription(value[i].value,value[i].description);
                                    }
                                }
                            }*/
                            oComponent.update(key,value);
                        }
                    }
                }
            },
            UIComponent:{
                Parameter: function(e,oUIComponent,key,value){
                    console.debug(e.type);
                    oUIComponent.setParamVal(key,value);
                },
                _Map:{
                    Parameter: function(e,oMap,key,value){
                        console.debug(e.type);
                        //--console.log("%cDEPRECATED!!!","color:red; background-color:black;");
                        return;
                        
                        if(!oMap instanceof Map){
                            console.error("oMap is not a Map instance");
                            return;
                        }
                        
                        oMap[key] = value;
                    },
                    Component: {
                        New: function(e,oMap,oMapComonentReference){
                            console.debug(e.type);
                            //--console.log("%cDEPRECATED!!!","color:red; background-color:black;");
                            return;
                            
                            //Check
                            if(oMap == undefined && !oMap instanceof oMap){
                                console.error("Specify a Map where add a Component");
                                return;
                            }
                            if(oMapComonentReference == undefined){
                                console.error("Specify a Map component reference to be added to Map");
                                return;
                            }
                            
                            //Add Component to array
                            var preferences = application.getConfigParam("preferences");
                            oMap.components.push($.extend(true,oMapComonentReference,{ scaleFactor: preferences.interface.iconsScaleFactor }));
                        },
                        Remove: function(e){
                            console.debug(e.type);
                            //--console.log("%cDEPRECATED!!!","color:red; background-color:black;");
                            return;
                        }
                    }
                }
            },
            //NEW
            Map:{
                Parameter: function(e,oMap,key,value){
                    console.debug(e.type);
                    
                    if(!oMap instanceof Map){
                        console.error("oMap is not a Map instance");
                        return;
                    }
                    
                    oMap[key] = value;
                }
            },
            MapComponent:{
                Parameter: function(e,oMapComponent,key,value){
                    console.debug(e.type);
                    
                    if(!oMapComponent instanceof MapComponent){
                        console.error("oMap is not a Map instance");
                        return;
                    }
                    
                    switch(key){
                        //Component reference node
                        case "reference":
                            oMapComponent.setReference(value);
                            break;
                        default:
                            oMapComponent[key] = value;
                    }
                }
            },
            Relation: {
                //Update user parameter
                Parameter: function(e,oRelation,key,param){
                    console.debug(e.type);

                    if(!oRelation instanceof Relation){
                        console.error("oRelation is not a Relation instance");
                        return;
                    }
                    oRelation.setParamVal(key,param);
                }
            }
        }
    },
    View:{
        Refresh:{
            User: {
                //Update user parameter
                Parameter: function(e,oUser,key,param){
                    if (key=="name")
                    {
                        $("#"+oUser.id).find("#name").text(oUser.name);
                        console.debug(e.type);
                    }

                }

            },
            Gateway:{
                //Refresh gateway name
                Name: function(e,oGateway){
                    console.debug(e.type);
                    $("#"+ oGateway.id +" .name").text(oGateway.getName());                                         //Update gateway list
                    $.publish("/view/gateways/refresh/dependencies");
                },
                //Refresh gateway protocol
                Protocol: function(e,oGateway){
                    console.debug(e.type);
                    $("#"+ oGateway.id +" .protocol").text(oGateway.getProtocol());
                    $.publish("/view/gateways/refresh/dependencies");
                },
                //Refresh gateway parameter
                Parameter: function(e,oGateway,key){
                    console.debug(e.type);
                    //$.publish("/view/gateways/refresh/dependencies");
                },
                //Refresh gateway dependencies
                Dependencies: function(e){
                    console.debug(e.type);
                    var $gateways = $("#componentproperties .container [eve-manager-id='gateway']");
                    var aNodes = eveManager.getGatewaysRoot().children;
                    var $selected = $gateways.find(":selected");
                    var oSelected = $selected.data("eveManagerNode");
                    var bFind = false;
                    
                    //Check if at least one node option is selected
                    if(oSelected == undefined){
                        oSelected = eveManager.getSelectGateway();                              //If any option is selected, choose Eve Manager current selected gateway
                    }
                    
                    //HTML Element isn't ready, jump
                    if($gateways.length > 0){
                        $gateways.empty();                                                          //Empty gateways select html element    
                    
                        for(var i=0; i<aNodes.length; ++i){
                            var oNode = aNodes[i];
                            var oGateway = oNode.getData();
                            var $option = $("<option></option>");
                            var strProtocol = oGateway.getProtocol();
                            
                            $option.text(oGateway.getName() +" - "+ eveManager.protocolsLabel[strProtocol]);
                            $option.val(strProtocol);
                            $option.data("eveManagerNode",oNode);                                   //Set related gateway node to option
                            $gateways.append($option);                                              //Append option
                            
                            //Select gateway selected before
                            if(oNode === oSelected){
                                $option.prop("selected",true);
                                bFind = true;
                            }
                            
                            //Select first gateway if anyone is selected
                            if(i == (aNodes.length-1) && !bFind){
                                console.warn("Any gateway is selected in eveManager, instance of Application");
                            }
                        }
                        
                        //Check gateway is selected
                        if(!bFind){
                            console.warn("Any gateway is selected in eveManager, instance of Application");
                            console.error("Any gateway is selected in eveManager, instance of Application");
                        }
                    }
                },
                //Refresh gateway properties
                Properties: function(e,oGateway){
                    console.debug(e.type);
                    var $loadContent = $("#gateway-properties .container");

                    onUpdateGateway(oGateway);

                    // Set name
                    var $elem = $loadContent.find("[eve-manager-id='name']");
                    $elem.val(oGateway.getName());
                    $elem[0].select();
                    
                    //Set protocol
                    var $elem = $loadContent.find("[eve-manager-id='protocol'] option");
                    var bFind = false;

                    //console.error(oGateway.getProtocol());
                    for(var i=0; i<$elem.length; ++i){
                        if($($elem[i]).val() == oGateway.getProtocol()){
                            $($elem[i]).prop("selected",true);
                            bFind = true;
                            
                            //Select protocol properties
                            $("#gateway-properties .container [eve-manager-protocol='"+ oGateway.getProtocol() +"']").show();
                            break;
                        }
                    }
                    if(!bFind){
                        console.warn("Any %c"+ oGateway.getProtocol() +" %cprotocol found","color:red","color:black");
                    }
                    
                    //Protocol parameters
                    var oData = oGateway.getData();
                    for(var k in oData){
                        var $prop = $("#gateway-properties .container [eve-manager-id='"+ k +"']");
                        
                        //Input type text
                        if($prop.attr("type") == "text"){
                            $prop.val(oData[k]);
                        }
                        //Input type checkbox
                        else if($prop.attr("type") == "checkbox"){
                            $prop.prop("checked",oData[k]);
                        }
                    }
                }
            },
            Component:{
                //Refresh component parameters (eg. name)
                Parameter: function(e,oComponent,key){
               //     console.debug(e.type);
                    var $element = $("#"+ oComponent.id);
                    
                    //Switch parameter
                    switch(key){
                        case "name":
                        {
                            var newName=oComponent.getParamVal("name");
                            if(oComponent.getType() == "group"){
                                $element.find("> h3 .group-text").text(newName);
                            }
                            else{
                                $element.find(".components-text").text(newName);
                            }

                            try{
                                $element.attr("name",newName.toLowerCase());
                            }catch(err){
                                console.log(err);
                            }
                            // cambia le label a tutte le icone nelle interfacce

                            var uiElements=oComponent.getParamVal("interfacesLinkedUIComponents");
                            for (var ii=0;ii<uiElements.length;ii++)
                            {
                                uiElements[ii].data.name=newName;
                                $("#"+uiElements[ii].data.id+" .name").text(newName);
                            }

                            break;

                        }
                        case "icons":
                        {
                            //console.warn("%cDisabled icon","background-color: red; color: white;");
                            //break;
                            var $Elem = $("#componentproperties").find("[eve-manager-id='icons']");
                            $Elem.empty();
                            var aIcons = oComponent.getParamVal("icons");

                            if(aIcons == undefined || aIcons.length < 1){
                                break;
                            }

                            for(var i=0; i<aIcons.length; ++i){
                                var oIcon = aIcons[i];
                                // console.log(application.ResoucesManager);
                                // console.log(document);
                                // console.log(oIcon.srcId);
                                // console.log(i);
                                oIcon.srcId=="app/resource/0";
                                var oPan = application.ResoucesManager.getIconsPanById(oIcon.srcId);
                                // console.log("oPan:"+oPan);
                                var $wrapper = $("<div class='icon'></div>");
                                var $canvas = $("<canvas></canvas>");
                                var $status = $("<span></span>");
                                // console.log(oPan);

                                var img = document.getElementById(oPan["id"]);

                                if(img == undefined){
                                    console.error("Any icons pan reference");
                                    return;
                                }

                                //Default image loading
                                var imgHeight = parseInt(oPan["params"]["imgHeight"],10);                        // Image height
                                var imgWidth = parseInt(oPan["params"]["imgWidth"],10);                          // Image width
                                var stretchScale = 1;

                                if(oIcon.size.w > 64){
                                    stretchScale = 0.5;
                                }

                                var drawHeight = imgHeight * stretchScale;
                                var drawWidth = imgWidth * stretchScale;
                                var canvas = $canvas[0];
                                var cont = canvas.getContext("2d");

                                $canvas.attr("height",oIcon.size.h*stretchScale);
                                $canvas.attr("width",oIcon.size.w*stretchScale);

                                //Height - Width streched
                                cont.drawImage(img,(oIcon.position.x*stretchScale),(oIcon.position.y*stretchScale),drawWidth,drawHeight);

                                var imageData = cont.getImageData(0,0,oIcon.size.w,oIcon.size.h);
                                //var imageData = cont.getImageData(0,0,64,64);

                                //Color image
                                if(oIcon.enableColors){
                                    //Color image
                                    for(var j=0; j<imageData.data.length; j+=4){
                                        imageData.data[j+0] = oIcon.color.R;
                                        imageData.data[j+1] = oIcon.color.G;
                                        imageData.data[j+2] = oIcon.color.B;
                                        imageData.data[j+3] = imageData.data[j+3];
                                    }
                                }

                                cont.putImageData(imageData,0,0);

                                $status.text(oIcon.status);

                                //Change icon in component properties
                                $wrapper.append($canvas);
                                $wrapper.append($status);
                                $Elem.append($wrapper);

                                if(i>0){
                                    continue;
                                }

                                //Change icon in my components
                                continue;
                                var $myComponentElement = $("#"+ oComponent.id);
                                var $componentsCanvas = $myComponentElement.find(" > .icon canvas");
                                var myComponentsCont = $componentsCanvas[0].getContext('2d');

                                //set dimensions
                                $componentsCanvas.attr("height",oIcon.size.h*stretchScale);
                                $componentsCanvas.attr("width",oIcon.size.w*stretchScale);

                                //apply the old canvas to the new one
                                myComponentsCont.drawImage(canvas,0,0);
                            }

                            if($Elem.find(".icon").length < 1){
                                var $div = $("<div></div>");
                                $div.css("height","64px").css("width","100%").text(_D("Any icon"));
                                $Elem.append($div);
                            }

                            //Refresh single component references
                            $.publish("/view/component/"+ oComponent.id +"/refresh/references",[oComponent]);
                            break;
                        }

                        case "values":
                            $.publish("/view/component/"+ oComponent.id +"/refresh/references",[oComponent]);
                            break;
                        case "knx/write-address":
                        case "knx/feedback-address":
                        //RGB Components
                        case "knx/red/write-address":
                        case "knx/green/write-address":
                        case "knx/blue/write-address":
                        case "knx/red/feedback-address":
                        case "knx/green/feedback-address":
                        case "knx/blue/feedback-address":
                        //Shutter Components
                        case "knx/long-operation/write-address":
                        case "knx/short-operation/write-address":
                        case "knx/long-operation/feedback-address":
                        case "knx/short-operation/feedback-address":
                            $.publish("/view/imported/projects/knx/refresh/address");
                            break;
                        case "vimar/enable-sfbk":
                            $("#componentproperties").find("[eve-manager-id='vimar/sfbk']").prop("disabled",! oComponent.getParamVal("vimar/enable-sfbk"));
                            break;
                        case "uservisibility":
                            //$element

                            $element.prop("uservisibility",oComponent.getParamVal("uservisibility"));
                            $element.attr("em-user-visibility",oComponent.getParamVal("uservisibility"));

                            /*if(oComponent.getParamVal("uservisibility")){
                                $element.attr("em-user-visibility",oComponent.getParamVal("uservisibility"));
                            }
                            else{
                                $element.removeAttr("em-user-visibility");
                            }*/
                            //alert($element.prop("uservisibility"));
                            break;
                        case "gui/src":
                            $("#componentproperties").find("[eve-manager-id='gui/src']").attr("src",oComponent.getParamVal("gui/src"));
                            break;
                    }
                    //onUpdateComponent(oComponent);
                    //Refresh components dependencies
                    //$.publish("/view/components/refresh/dependencies");
                },
                //Refresh component properties
                Properties: function(e,oComponent){
                    //console.debug(e.type);
                    //console.log("Update Componet Callback");

                    /*
                        onUpdateComponent(eventData);
                    */

                    var eventData = new blrComponentEventData(
                        "application-patterns.js",
                        $("#componentproperties"),
                        oComponent
                    );

                    eventData.$properties().find("[eve-manager-components='mainframe']").html(QT.readFile("./components/mainframe/components-mainframe.html"));
                    eventData.$properties().find("[eve-manager-components='bottom']").html(QT.readFile("./components/mainframe/bottom-prop.html"));
                    COMPONENTS_MAINFRAME.onGuiChangeGatewayCallbackUserData = eventData;
                    COMPONENTS_MAINFRAME.onGuiChangeGatewayCallback = onGuiChangeGateway;
                    try {
                        onInitComponent(eventData);
                        onUpdateComponent(eventData);
                    }
                    catch(e)
                    {
                        console.log("onInitComponent does not exist");
                    }
                    var $nameField = eventData.$properties().find("[eve-manager-id='name']");
                    //Select name field
                    if($nameField.length > 0){
                        $nameField[0].select();
                    }

                    eventData = null;

                },
                //Refresh component references (eg. icon on interface or map's components)
                References: function(e,oComponent){
                    console.debug(e.type);
                    
                    var aNodes = oComponent.getParamVal("interfacesLinkedUIComponents");
                    var aIcons = oComponent.getParamVal("icons");
                    var oIcon;
                    
                    //No icons (eg. groups)
                    if(!(aIcons instanceof Array)){
                        return;
                    }
                    
                    //Get status 0 icon
                    for(var i=0; i<aIcons.length; ++i){
                        if(aIcons[i].status == 0){
                            oIcon = aIcons[i];
                            break;
                        }
                    }
                    
                    //No related UIComponent
                    if(!aNodes instanceof Array || aNodes.length < 1){
                        return;
                    }
                    
                    //Update UIComponent icons
                    for(var i=0; i<aNodes.length; ++i){
                        //console.log("UIComponent update");
                        var oData = aNodes[i].getData();
                        var oUIIcon;
                        
                        //Edit UIComponent reference
                        if(oData instanceof UIComponent){
                            oUIIcon = oData.getParamVal("icon");

                            $.extend(true,oUIIcon,oIcon);

                            //Edit changes
                            $.publish("/model/uicomponents/"+ oData.id +"/update/parameter",[oData,"icon",oUIIcon]);
                            $.publish("/view/uicomponents/"+ oData.id +"/refresh/parameter",[oData,"icon"]);
                        }
                        
                        //Edit MapComponent reference
                        if(oData instanceof MapComponent){
                            //oUIIcon = oData.getParamVal("icon");
                            var aComponentStatus = new Array();
                            var aNewIcons = new Array();
                            //$.extend(true,aNewIcons,oData.icons);

                            //Create status array
                            for(var j=0; j<aIcons.length; ++j){
                                aComponentStatus.push(parseInt(aIcons[j].status,10));
                            }

                            //Push only existing status
                            for(var j=0; j<oData.icons.length; ++j){

                                if(aComponentStatus.indexOf(parseInt( oData.icons[j].status,10) ) != -1){
                                    aNewIcons.push($.extend(true,{},oData.icons[j]));

                                    //Remove status from array status
                                    aComponentStatus.splice(aComponentStatus.indexOf(parseInt( oData.icons[j].status,10) ),1);
                                }
                            }

                            //Add missing status
                            for(var j=0; j<aComponentStatus.length; ++j){
                                for(var h=0;h<aIcons.length;++h){
                                    if(aComponentStatus[j] == parseInt(aIcons[h].status,10)){
                                        aNewIcons.push($.extend(true,{},aIcons[h]));
                                    }
                                }
                                //console.error(aComponentStatus[j]);
                            }

                            //Edit changes
                            //console.error(oData);
                            //$.extend(true,oUIIcon,oIcon);
                            //console.error(aComponentStatus);
                            //console.error(oData.icons);
                            //console.error(aNewIcons);

                            $.publish("/model/uicomponent/map/mapcomponent/"+ oData.id +"/update/parameter",[oData,"icons",aNewIcons]);
                            $.publish("/view/uicomponent/map/mapcomponent/"+ oData.id +"/refresh/parameter",[oData,"icons"]);
                        }

                        //var oUIComponent = aNodes[i].getData();
                        //var oUIIcon = oUIComponent.getParamVal("icon");
                        
                        //$.extend(true,oUIIcon,oIcon);   
                        
                        //Edit changes
                        //$.publish("/model/uicomponents/"+ oUIComponent.id +"/update/parameter",[oUIComponent,"icon",oUIIcon]);
                        //$.publish("/view/uicomponents/"+ oUIComponent.id +"/refresh/parameter",[oUIComponent,"icon"]);
                    }
                    
               /*     //Update Map component (redraw map temporary)
                    var oUINode = application.getSelectUIComponent();
                    if(oUINode == undefined){ return; }
                    application.selectUIComponent(oUINode);
                */},
                //Refresh component dependencies
                Dependencies: function(e,bImport){
                    return;
                    //console.debug(e.type);

                    //setTimeout(function(){
                    var $originalContainer = $("#componentscontainer");                                     //Get original components container
                    var $originalComponents = $originalContainer.children();                                //Get cloned html components
                    
                    //Refresh interface component library
                    if (!bImport && $("#myinterface").is(":visible")) {
                        var $clonedComponents = $originalContainer.children().clone(true, true);                 //Get cloned html components
                        var $interface = $("#interface-elements");                                              //Get interface html element
                        var $componentsSet = $interface.find("#interface-components");                          //Get interface component set

                        /** Fill interface components */
                        $componentsSet.empty();                                                                 //Empty all contents

                        $componentsSet.append('<li class="finder"><input type="text" id="components-finder" /><span class="ui-icon ui-icon-search">&nbsp;</span><br style="clear: both" /></li>');
                        $componentsSet.append('<span class="ui-icon ui-icon-search" style="float:right;">&nbsp;</span>');

                        //$componentsSet.append('<br style="clear: both" />');
                        $componentsSet.append($clonedComponents);                                               //Append cloned components
                        $componentsSet.find("[eve-manager-component]").removeClass("select");                   //Remove select class
                        $componentsSet.find("[eve-manager-component]").removeClass("ui-state-active");          //Remove "active" state
                        $componentsSet.find("[eve-manager-component]").removeAttr("id");                        //Remove id attributes
                        $componentsSet.find(".eve-values").remove();                                            //Remove id attributes

                        //Exclude group
                        var $noGroupComponents = $componentsSet.find("[eve-manager-component]:not([eve-manager-component='group'])");

                        //Draw icons in canvas
                        for(var i=0; i<$noGroupComponents.length; ++i){
                            var $clonedComponent = $($noGroupComponents[i]);
                            var oNode = $clonedComponent.data("eveManagerNode");

                            if(oNode == undefined){
                                continue;
                            }

                            var oComponent = oNode.getData();
                            var $clonedCanvas = $clonedComponent.find("> .icon canvas");

                            if($clonedCanvas.length < 1){
                                continue;
                            }

                            var context = $clonedComponent.find(".icon canvas")[0].getContext('2d');
                            context.drawImage($("#"+ oComponent.id).find(".icon canvas")[0], 0, 0);     //Get original canvas
                        }
                        

                        //Create draggable elements
                        //var strInterfaceElementSelector = "#interface-elements #interface-icons li, #interface-elements #interface-components li";
                        var strInterfaceElementSelector = "#interface-elements #interface-components li";
                        /*var draggableProperties = {
                            appendTo: "body",
                            containment: "body", 
                            revert: "invalid",
                            revertDuration: false,
                            helper: function(e){ return $(e.currentTarget).clone(true); },
                            zIndex: 1000
                        };*/

                        //Create draggable elements
                        var strConnectWith = "#myinterface .level, #interface-maps .maps-container .viewer";

                        $(strInterfaceElementSelector).draggable({
                            appendTo: "body",
                            containment: "body",
                            revert: "invalid",
                            revertDuration: false,
                            connectToSortable: strConnectWith,
                            //helper: "clone",
                            helper: function(e){ return $(e.currentTarget).clone(true); },
                            zIndex: 1000
                        });

                        $componentsSet.find(".extra").hide();
                        $componentsSet.find("[eve-manager-component='label']").removeClass("special");

                        //Hide
                        //console.log( $componentsSet.find("[em-user-visibility]").length )
                        var oUser = application.getUserByName(presenter.preferences.getParameter("currentUser"));

                        if(oUser != undefined && !oUser.getData().getPermission(11)){
                            $componentsSet.find("[em-user-visibility='false']").hide();
                        }


                        //if(presenter.preferences.getParameter()){}
                        //$componentsSet.find("[em-user-visibility='false']").hide();
                    }

                    //Refresh interface component library
                    if (!bImport && $("#lists").is(":visible")) {
                        var $clonedComponents = $originalContainer.children().clone(true, true);                 //Get cloned html components
                        var $interface = $("#lists-elements");                                                  //Get interface html element
                        var $componentsSet = $interface.find("#lists-components");                              //Get interface component set

                        /** Fill interface components */
                        $componentsSet.empty();                                                                 //Empty all contents

                        $componentsSet.append('<li class="finder"><input type="text" id="components-finder" /><span class="ui-icon ui-icon-search">&nbsp;</span><br style="clear: both" /></li>');
                        //$componentsSet.append('<span class="ui-icon ui-icon-search" style="float:right;">&nbsp;</span>');

                        //$componentsSet.append('<br style="clear: both" />');
                        $componentsSet.append($clonedComponents);                                               //Append cloned components
                        $componentsSet.find("[eve-manager-component]").removeClass("select");                   //Remove select class
                        $componentsSet.find("[eve-manager-component]").removeClass("ui-state-active");          //Remove "active" state
                        $componentsSet.find("[eve-manager-component]").removeAttr("id");                        //Remove id attributes
                        $componentsSet.find(".eve-values").remove();                                            //Remove id attributes

                        //Exclude group
                        var $noGroupComponents = $componentsSet.find("[eve-manager-component]:not([eve-manager-component='group'])");

                        //Draw icons in canvas
                        for(var i=0; i<$noGroupComponents.length; ++i){
                            var $clonedComponent = $($noGroupComponents[i]);
                            var oNode = $clonedComponent.data("eveManagerNode");

                            if(oNode == undefined){
                                continue;
                            }

                            var oComponent = oNode.getData();
                            var $clonedCanvas = $clonedComponent.find("> .icon canvas");

                            if($clonedCanvas.length < 1){
                                continue;
                            }

                            var context = $clonedComponent.find(".icon canvas")[0].getContext('2d');
                            context.drawImage($("#"+ oComponent.id).find(".icon canvas")[0], 0, 0);     //Get original canvas
                        }

                        //Create draggable elements
                        var strInterfaceElementSelector = "#lists-elements #lists-components li";

                        //Create draggable elements
                        var strConnectWith = "#mylists .level";

                        $(strInterfaceElementSelector).draggable({
                            appendTo: "body",
                            containment: "body",
                            revert: "invalid",
                            revertDuration: false,
                            connectToSortable: strConnectWith,
                            //helper: "clone",
                            helper: function(e){ return $(e.currentTarget).clone(true); },
                            zIndex: 1000
                        });

                        $componentsSet.find(".extra").hide();
                        $componentsSet.find("[eve-manager-component='label']").removeClass("special");

                        //Hide
                        //console.log( $componentsSet.find("[em-user-visibility]").length )
                        var oUser = application.getUserByName(presenter.preferences.getParameter("currentUser"));

                        if(oUser != undefined && !oUser.getData().getPermission(11)){
                            $componentsSet.find("[em-user-visibility='false']").hide();
                        }
                    }

                    if (!bImport && $("#relations").is(":visible")) {
                        var $clonedComponents = $originalContainer.children().clone(true, true);                 //Get cloned html components
                        var $relations = $("#relations");                                                       //Get relations html element
                        var $relationsSet = $relations.find("#relations-components .container");                //Get relations component set

                        /** Fill relations components */
                        $relationsSet.empty();                                                                 //Empty all contents
                        $relationsSet.append($clonedComponents.clone(true,true));                              //Append cloned components
                        $relationsSet.find("[eve-manager-component]").removeClass("select");                   //Remove select class
                        $relationsSet.find("[eve-manager-component]").removeClass("ui-state-active");          //Remove "active" state
                        $relationsSet.find("[eve-manager-component]").removeAttr("id");                        //Remove id attributes
                        $relationsSet.find(".eve-values").remove();                                             //Remove id attributes

                        //Exclude group
                        var $noGroupComponents = $relationsSet.find("[eve-manager-component]:not([eve-manager-component='group'])");

                        //Draw icons in canvas
                        for(var i=0; i<$noGroupComponents.length; ++i){
                            var $clonedComponent = $($noGroupComponents[i]);
                            var oNode = $clonedComponent.data("eveManagerNode");

                            if(oNode == undefined){
                                continue;
                            }

                            var oComponent = oNode.getData();
                            var $clonedCanvas = $clonedComponent.find("> .icon canvas");

                            if($clonedCanvas.length < 1){
                                continue;
                            }

                            var context = $clonedComponent.find(".icon canvas")[0].getContext('2d');
                            context.drawImage($("#"+ oComponent.id).find(".icon canvas")[0], 0, 0);     //Get original canvas
                        }

                        //Create draggable elements
                        //var strInterfaceElementSelector = "#interface-elements #interface-icons li, #interface-elements #interface-components li";
                        var strInterfaceElementSelector = "#relations-components > .container li";

                        //Create draggable elements
                        var strConnectWith = "#myrelations .relations-container .source, #myrelations .relations-container .destination";

                        $(strInterfaceElementSelector).draggable({
                            appendTo: "body",
                            containment: "body",
                            revert: "invalid",
                            revertDuration: false,
                            connectToSortable: strConnectWith,
                            helper: function(e){ return $(e.currentTarget).clone(true); },
                            zIndex: 1000
                        });

                        /*var draggableProperties = {
                         appendTo: "body",
                         containment: "body",
                         revert: "invalid",
                         revertDuration: false,
                         helper: function(e){ return $(e.currentTarget).clone(true); },
                         zIndex: 1000
                         };*/

                        //Create draggable elements
                        /*var strConnectWith = "#myinterface .level, #interface-maps .maps-container .viewer";

                        $(strInterfaceElementSelector).draggable({
                            appendTo: "body",
                            containment: "body",
                            revert: "invalid",
                            revertDuration: false,
                            connectToSortable: strConnectWith,
                            //helper: "clone",
                            helper: function(e){ return $(e.currentTarget).clone(true); },
                            zIndex: 1000
                        });*/

                        $relationsSet.find(".extra").hide();
                    }

                    //console.error($("#myinterface").is(":visible"));


                    return; //Refresh dei valori solo quando l'area è visibile


                    var $interface = $("#interface-elements");                                              //Get interface html element
                    var $componentsSet = $interface.find("#interface-components");                          //Get interface component set
                    //var $componentsSet = $("#interface-components, #relations-components .container");      //Get interface component set

                    /** Fill interface components */
                    $componentsSet.empty();                                                                 //Empty all contents
                    $componentsSet.append($clonedComponents);                                               //Append cloned components
                    $componentsSet.find("[eve-manager-component]").removeClass("select");                   //Remove select class 
                    $componentsSet.find("[eve-manager-component]").removeClass("ui-state-active");          //Remove "active" state
                    $componentsSet.find("[eve-manager-component]").removeAttr("id");                        //Remove id attributes

                    //$relationsSet.empty();                                                                   //Empty all contents
                    //$relationsSet.append($clonedComponents.clone(true,true));                                //Re-clone and append cloned components
                    //$relationsSet.append($clonedComponents);                                                 //Re-clone and append cloned components
                    //$relationsSet.find("[eve-manager-component]").removeClass("select");                   //Remove select class
                    //$relationsSet.find("[eve-manager-component]").removeClass("ui-state-active");          //Remove "active" state
                    //$relationsSet.find("[eve-manager-component]").removeAttr("id");                        //Remove id attributes
                    
                    //Exclude group
                    var $noGroupComponents = $componentsSet.find("[eve-manager-component]:not([eve-manager-component='group'])");
                    
                    //Draw icons in canvas
                    for(var i=0; i<$noGroupComponents.length; ++i){
                        var $clonedComponent = $($noGroupComponents[i]); 
                        var oNode = $clonedComponent.data("eveManagerNode");
                        
                        if(oNode == undefined){
                            continue;
                        }
                        
                        var oComponent = oNode.getData();
                        var $clonedCanvas = $clonedComponent.find("> .icon canvas");
                        
                        if($clonedCanvas.length < 1){
                            continue;
                        }
                        
                        var context = $clonedComponent.find(".icon canvas")[0].getContext('2d');
                        context.drawImage($("#"+ oComponent.id).find(".icon canvas")[0], 0, 0);     //Get original canvas
                    }
                    
                    //Create draggable elements
                    //var strInterfaceElementSelector = "#interface-elements #interface-icons li, #interface-elements #interface-components li";
                    var strInterfaceElementSelector = "#interface-elements #interface-components li";

                    //Create draggable elements
                    var strConnectWith = "#myinterface .level, #interface-maps .maps-container .viewer";
                    
                    $(strInterfaceElementSelector).draggable({
                        appendTo: "body",
                        containment: "body",
                        revert: "invalid",
                        revertDuration: false,
                        connectToSortable: strConnectWith,
                        //helper: "clone",
                        helper: function(e){ return $(e.currentTarget).clone(true); },
                        zIndex: 1000
                    });
                }
            },
            UIComponent:{
                Parameter: function(e,oUIComponent,key){
                    console.debug(e.type);
                    
                    var strId = oUIComponent.id;
                    var $element = $("#"+ strId);
                    var $element2 = $("#mylists").find("[list-id='"+ strId +"']");

                    //Update parameter
                    switch(key){
                        case "name":
                            $element.find(".name").text(oUIComponent.getParamVal(key));
                            $element2.find(".name").text(oUIComponent.getParamVal(key));

                            //Set name in maps tool bar
                            if($element.hasClass("select") && $element.parent().attr("id") == "level-1" && $("#interface-maps .map-tools").is(":visible")){
                                $("#interface-maps .map-tools").find(".title").text(oUIComponent.getParamVal(key));
                            }
                            break;
                        case "icon":
                            var oIcon = oUIComponent.getParamVal("icon");
                            var $canvas = $element.find(".icon > canvas");
                            var img = document.getElementById(oIcon.srcId);
                            //var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");
                            
                            $canvas.remove();
                            $canvas = $("<canvas></canvas>");
                            
                            //Default image loading
                            var imgHeight = parseInt(oIcon.setSize.h,10);                         // Image height
                            var imgWidth = parseInt(oIcon.setSize.w,10);                          // Image width
                            var stretchScale = 1;
                            
                            if(oIcon.size.w > 64){
                                stretchScale = 0.5;
                            }
                            
                            var drawHeight = imgHeight * stretchScale;
                            var drawWidth = imgWidth * stretchScale;
                            var canvas = $canvas[0];
                            var cont = canvas.getContext("2d");
                            
                            $canvas.attr("height",oIcon.size.h * stretchScale);
                            $canvas.attr("width",oIcon.size.w * stretchScale);
                            //console.log(oIcon.position.x);
                            if (oIcon.position.x=="null")
                                oIcon.position.x=0;
                            if (oIcon.position.y=="null")
                                oIcon.position.y=0;

                            //Height - Width stretched
                            if (img!=null)
                                cont.drawImage(img,(oIcon.position.x * stretchScale),(oIcon.position.y * stretchScale),drawWidth,drawHeight);
                            
                            var imageData = cont.getImageData(0,0,drawWidth,drawHeight);
                            //var imageData = cont.getImageData(0,0,64,64);
                            
                            //Color image
                            if(oIcon.enableColors){
                                //Color image
                                for(var j=0; j<imageData.data.length; j+=4){
                                    imageData.data[j+0] = oIcon.color.R;
                                    imageData.data[j+1] = oIcon.color.G;
                                    imageData.data[j+2] = oIcon.color.B;
                                    imageData.data[j+3] = imageData.data[j+3];
                                }
                            }
                            
                            cont.putImageData(imageData,0,0);
                            
                            $element.find(".icon").append($canvas);

                            var $oldCanvas = $element.find("canvas")[0];

                            $element2.find(".icon").empty();
                
                            $element2.find(".icon").append(bigh.cloneCanvas($oldCanvas));

                            break;
                    }//end switch
                }
            },
            Map:{
                Parameter: function(e,oMap,key){
                    console.debug(e.type);
                    if(!oMap instanceof Map){
                        console.error("oMap is not a Map instance");
                        return;
                    }
                    
                    //Write name case
                    var $map = $("#"+ oMap.id);
                    var $mapContainer = $map.parent();
                    
                    switch(key){
                        case "trasparent":
                            var $viewer = $map.find(".viewer");
                            
                            //Set background
                            if(oMap[key]){
                                $viewer.css("background-color", "trasparent");
                                $viewer.css("background-image", "url('./assets/img/bg-pattern.jpg')");
                            }
                            else{
                                $viewer.css("background-color", bigh.rgb2hex(oMap["color"].R, oMap["color"].G, oMap["color"].B));
                                $viewer.css("background-image", "none");
                            }
                            break;
                        case "color":
                            var $viewer = $map.find(".viewer");
                            $viewer.css("background-color",bigh.rgb2hex(oMap[key].R, oMap[key].G, oMap[key].B));
                            break;
                        case "name":
                            if($map.length > 0){
                                $mapContainer.find("[href='#"+ oMap.id +"']").text(oMap[key]);
                            }
                            break;
                        case "imageVisible":
                            var $img = $map.find(".viewer img");
                            
                            //Set background
                            if(oMap[key]){
                                $img.show();
                            }
                            else{
                                $img.hide();
                            }
                            break;
                        case "background":
                            var img = new Image();
                            var $viewer = $map.find(".viewer");
                            
                            if(oMap[key] == undefined){
                                //console.warn("Any background image for this Map: "+ oMap);
                                return;
                            }
                            
                            $viewer.find("img").remove();
                            
                            img.src = oMap[key];
                            
                            //$(img).css("visibility","hidden");
                            img.style["visibility"] = "hidden";
                            img.onload = function(e){
                                var $img = $(img);
                                var imgWidth = img.width;
                                var imgHeight = img.height; 
                                var scale = parseFloat($viewer.width()) / imgWidth;
                                
                                img.width = parseInt(imgWidth*scale,10);
                                img.height = parseInt(imgHeight*scale,10);
                                
                                //Check image
                                var deltaH = $viewer.height() - img.height;
                                
                                $(img).css("margin-top",deltaH*0.5);
                                if(deltaH < 0){
                                    var scale = parseFloat($viewer.height()) / imgHeight;
                                    
                                    img.width = parseInt(imgWidth*scale,10);
                                    img.height = parseInt(imgHeight*scale,10);
                                    $(img).css("margin-top","0");
                                    
                                    var deltaW = $viewer.width() - img.width;
                                    $(img).css("margin-left",deltaW*0.5);
                                }
                                
                                //$(img).css("visibility","visible");
                                img.style["visibility"] = "visible";
                            };
                            $viewer.prepend(img);
                            
                            if(!oMap["imageVisible"]){
                                $viewer.find("img").hide();
                            }
                            break;
                    }
                }
            },
            MapComponent:{
                Parameter: function(e,oMapComponent,key){
                    console.debug(e.type);
                    
                    if(!oMapComponent instanceof MapComponent){
                        console.error("oMap is not a Map instance");
                        return;
                    }
                    
                    //Write name case
                    var $mapComponent = $("#"+ oMapComponent.id);
                    
                    switch(key){
                        case "name":
                            $mapComponent.find(".name").text(oMapComponent[key]);
                            break;

                        case "position":
                            //console.log (oMapComponent[key].y);
                            $mapComponent.css("top", oMapComponent[key].y +"px");
                            $mapComponent.css("left", oMapComponent[key].x +"px");
                            var oNode = application.getSelectMap();
                            var oMapComponentNode = $mapComponent.data("eveManagerNode");
                            var oMap = oNode.getData();
                            var oComponent = oMapComponent.getReference().getData();

                            break;
                        case "scaleFactorWidth":
                        case "scaleFactorHeight":
                        case "scaleFactor":
                            var oNode = application.getSelectMap();
                            var oMapComponentNode = $mapComponent.data("eveManagerNode");
                            var oMap = oNode.getData();
                            
                            if(!$("#"+ oMap.id).is(":visible")){
                                break;
                            }
                            //application.selectMap(oNode);

                            //console.error(oMapComponent);
                            //console.error($mapComponent.data("eveManagerNode"));

                            //TODO Prendere l'indice della posizione dell'oggetto grafico
                            $mapComponent.remove();

                            View.addMapComponent(oMapComponentNode,oNode);

                            break;
                            //TODO SISTEMARE IL FATTORE DI SCALA (disegno dentro al canvas)
                            var oComponent = oMapComponent.getReference().getData();
                            var aIcons = oComponent.getParamVal("icons");
                            var oIcon;
                            var $canvas = $mapComponent.find(".icon");
                            //var $canvas = $("<canvas></canvas>");
                            var cont = $canvas[0].getContext("2d");
                            
                            $canvas.css("border","solid 1px red");
                            
                            //cont.moveTo(0,0);
                            //cont.lineTo(100,100);
                            cont.scale(0.5,0.5);
                            //cont.stroke();
                            break;
                            //Get first icon
                            for(var k in aIcons){
                                oIcon = aIcons[k];
                                break;
                            }
                            
                            console.warn("Find a solution for img element id.\nId attribute don't work with "+ oIcon.src);
                            //var img = document.getElementById(oIcon.src);
                            var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");
                            var stretchScale = oIcon.scaleFactor * oMapComponent.scaleFactor;
                            var imgHeight = parseInt(img.height,10);                        // Image height
                            var imgWidth = parseInt(img.width,10);                          // Image width
                            var drawHeight = imgHeight * stretchScale;
                            var drawWidth = imgWidth * stretchScale;
                            
                            //Height - Width streched
                            //cont.clearRect(0,0,oIcon.size.w,oIcon.size.h);
                            cont.drawImage(img,(oIcon.position.x * stretchScale),(oIcon.position.y * stretchScale),drawWidth,drawHeight);
                            var imageData = cont.getImageData(0,0,oIcon.size.w,oIcon.size.h);
                            
                            //Color image
                            if(oIcon.enableColors){
                                //Color image
                                for(var j=0; j<imageData.data.length; j+=4){
                                    imageData.data[j+0] = oIcon.color.R;
                                    imageData.data[j+1] = oIcon.color.G;
                                    imageData.data[j+2] = oIcon.color.B;
                                    imageData.data[j+3] = imageData.data[j+3];
                                }
                            }
                            
                            cont.putImageData(imageData,0,0);
                            
                            $canvas.attr("height",oIcon.size.h * stretchScale);
                            $canvas.attr("width",oIcon.size.w * stretchScale);
                            
                            $canvas.addClass(".icon");
                            $mapComponent.find(".icon").remove();
                            $mapComponent.prepend($canvas);
                            
                            $mapComponent.height($canvas.attr("height"));
                            //$mapComponent.css("height","auto");
                            $mapComponent.width($canvas.attr("width"));

                            /*if(oMapComponent["viewmode"]){
                                $mapComponent.find(".icon").hide();
                                $mapComponent.css("height","auto");
                            }
                            else{
                                $mapComponent.find(".icon").show();
                            }*/
                            break;
                        case "icon":
                        case "icons":
                            var oNode = application.getSelectMap();
                            var oMapComponentNode = $mapComponent.data("eveManagerNode");
                            var oMap = oNode.getData();

                            if(!$("#"+ oMap.id).is(":visible")){
                                break;
                            }
                            
                            /*if(!$("#"+ oMap.id).is(":visible")){
                                break;
                            }*/


                            //TODO Prendere l'indice della posizione dell'oggetto grafico
                            $mapComponent.remove();

                            //application.selectMap(oNode);
                            View.addMapComponent(oMapComponentNode,oNode);
                            break;
                        /*case "icons":
                            //console.error("SISTEMARE L'ICONA (disegno dentro al canvas)!!!!");
                            var oNode = application.getSelectMap();
                            var oMap = oNode.getData();

                            //if(!$("#"+ oMap.id).is(":visible")){
                            //    break;
                            //}
                            application.selectMap(oNode);
                            break;*/
                        case "viewmode":
                            if($("#interface-maps #viewLevel").find(":selected").val() != "1"){
                                break;
                            }

                            var $canvas = $mapComponent.find(".icon");
                            switch(oMapComponent[key]){
                                case 3:
                                    //$mapComponent.find(".icon").hide();
                                    //$mapComponent.find(".name").hide();
                                    //$mapComponent.find(".label").show();
                                    $mapComponent.fadeTo( "fast", 0.33 );
                                    //$mapComponent.css("height","auto");
                                    //$mapComponent.height($mapComponent.find(".label").attr("height"));
                                    //$mapComponent.height($mapComponent.find(".label").height());
                                    //$mapComponent.width($mapComponent.find(".label").attr("width"));
                                    break;
                                default:
                                    //$mapComponent.find(".icon").show();
                                    //$mapComponent.find(".name").show();
                                    $mapComponent.fadeTo( "fast", 1 );
                                //$mapComponent.find(".label").hide();
                                //$mapComponent.height($canvas.attr("height"));
                                //$mapComponent.width($canvas.attr("width"));
                            }
                            break;
                        case "viewmode2":
                            if($("#interface-maps #viewLevel").find(":selected").val() != "2"){
                                break;
                            }

                            var $canvas = $mapComponent.find(".icon");
                            switch(oMapComponent[key]){
                                case 3:
                                    $mapComponent.fadeTo( "fast", 0.33 );
                                    break;
                                default:
                                    $mapComponent.fadeTo( "fast", 1 );
                            }
                            break;
                        case "viewmode3":
                            if($("#interface-maps #viewLevel").find(":selected").val() != "3"){
                                break;
                            }

                            var $canvas = $mapComponent.find(".icon");
                            switch(oMapComponent[key]){
                                case 3:
                                    $mapComponent.fadeTo( "fast", 0.33 );
                                    break;
                                default:
                                    $mapComponent.fadeTo( "fast", 1 );
                            }
                            break;
                        case "viewmode4":
                            if($("#interface-maps #viewLevel").find(":selected").val() != "4"){
                                break;
                            }

                            var $canvas = $mapComponent.find(".icon");
                            switch(oMapComponent[key]){
                                case 3:
                                    $mapComponent.fadeTo( "fast", 0.33 );
                                    break;
                                default:
                                    $mapComponent.fadeTo( "fast", 1 );
                            }
                            break;
                        case "viewmode5":
                            if($("#interface-maps #viewLevel").find(":selected").val() != "5"){
                                break;
                            }

                            var $canvas = $mapComponent.find(".icon");
                            switch(oMapComponent[key]){
                                case 3:
                                    $mapComponent.fadeTo( "fast", 0.33 );
                                    break;
                                default:
                                    $mapComponent.fadeTo( "fast", 1 );
                            }
                            break;
                        case "uiDisableCircle":

                            break;
                        case "uiReadOnly":

                            break;
                        case "hideIconComponent":

                            break;
                        case "hideIconComponentValue":

                            break;
                        case "disableIconComponent":

                            break;
                        case "disableIconComponentValue":

                            break;


                        default:
                            console.error("Complete method for: "+ key);
                    }
                }
            },
            Relation:{
                Parameter: function(e,oRelation,key){
                  //  console.debug(e.type);

                    if(!oRelation instanceof Relation){
                        console.error("oRelation is not a Relation instance");
                        return;
                    }

                    //Write name case
                    var $relation = $("#"+ oRelation.id);

                    switch(key){
                        case "source":
                            var oNode = oRelation.getParamVal("source")
                            var oParentNode = oNode.getParent();
                            var oComponent = oNode.getData();
                            var oGroup = oParentNode.getData();
                            var strHTML = "";

                            if(oGroup.getParamVal != undefined && oGroup.getParamVal("name") != undefined){
                                strHTML += oGroup.getParamVal("name") +" > ";
                            }

                            strHTML += oComponent.getParamVal("name") +"<br />";
                            strHTML += _D("Type") +": "+ oComponent.getType();

                            $relation.find(".source").html(strHTML).removeClass("ui-widget-content").addClass("complete");
                            break;
                        case "destination":
                            var oNode = oRelation.getParamVal("destination")
                            var oParentNode = oNode.getParent();
                            var oComponent = oNode.getData();
                            var oGroup = oParentNode.getData();
                            var strHTML = "";

                            if(oGroup.getParamVal != undefined && oGroup.getParamVal("name") != undefined){
                                strHTML += oGroup.getParamVal("name") +" > ";
                            }

                            strHTML += oComponent.getParamVal("name") +"<br />";
                            strHTML += _D("Type") +": "+ oComponent.getType();

                            $relation.find(".destination").html(strHTML).removeClass("ui-widget-content").addClass("complete");
                            break;
                        case "operator":
                            break;
                        case "checkTime":
                            $relation.find(".checkTime").val(oRelation.getParamVal("checkTime"));
                            break;
                    }

                    if(oRelation.isComplete){
                        $relation.removeClass("incomplete");//.addClass("ui-widget-content");
                    }
                    else{
                        $relation.addClass("incomplete");
                    }
                }
            },
            Imported:{
                Projects:{
                    Knx: {
                        Address: function(e){
                            console.debug(e.type);

                            //Show all elements
                            $("#etsProject").find("[knx-group-address]").removeClass("jstree-knx-filter").show();
                            
                            //Check if filter is disable
                            if($("#etsProject form input[type='checkbox']").prop("checked")){
                                return;
                            }
                            
                            //Declare recursive function for decode components
                            function hideKnxGroupAddress(oNode){
                                var oComponent = oNode.getData();
                                
                                //Get KNX addresses
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                //RGB Components
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/red/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/green/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/blue/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/red/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/green/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/blue/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                //Shutter Components
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/long-operation/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/long-operation/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/short-operation/write-address") +"']").addClass("jstree-knx-filter").hide();
                                $("#etsProject").find("[knx-group-address='"+ oComponent.getParamVal("knx/short-operation/feedback-address") +"']").addClass("jstree-knx-filter").hide();
                                
                                for(var i=0;i<oNode.children.length;++i){
                                    hideKnxGroupAddress(oNode.children[i]);
                                }
                            };
                            
                            //Hide each used KNX group address
                            var oComponentsRoot = model["instance"].getComponentsRoot();
                            for(var i=0;i<oComponentsRoot.children.length;++i){
                                hideKnxGroupAddress(oComponentsRoot.children[i]);
                            }
                        }
                    }
                }
            },
            Application:{
                Connection: function(e,bConnection){

                    //Connected
                    if(bConnection){

                        //Graphic effect
                        /*
                        setTimeout(function(){
                            var $img = $("<img src='./assets/img/connected.png' height='160' width='160' style='position: absolute; bottom: 50px; right: 50px; font-size: 32px; background-color: #222; color: yellow; padding: 30px; border-radius: 30px; opacity: 1; display: block;' />");
                            $("body").append($img);
                            $img.animate({ opacity:.9 },200).animate({ opacity: 0 },{
                                duration: 200,
                                complete: function(){
                                    $img.remove();
                                }
                            });
                        },1);
                        */

                        //Disable menu
                        $("[eve-manager-mainmenu='projectmenu']").find("[eve-manager-menu='disconnect']").removeClass("ui-state-disabled");
                        $("[eve-manager-mainmenu='projectmenu']").find("[eve-manager-menu='connect']").addClass("ui-state-disabled");


                        QT.updateParameter = function(resp){
                        //    console.log(resp);
                            var oNode = application.getComponentByUid(resp.ParameterID);
                            if(oNode == undefined){ return; }

                            var oComponent = oNode.getData();
                            var $element = $("#createcomponents").find("#"+ oComponent.id);
                            $element.find(".eve-values").show();


                            //Switches
                            if(
                                $element.attr("eve-manager-component") == "switch" ||
                                $element.attr("eve-manager-component") == "lock" ||
                                $element.attr("eve-manager-component") == "pulse"
                            ){
                                if(parseInt(resp.value,10) == 1){
                                    $element.find(".eve-values").text("ON");
                                }
                                else{
                                    $element.find(".eve-values").text("OFF");
                                }

                            }
                            else if($element.attr("eve-manager-component") == "rgb-light"){
                                var hex = parseInt(resp.value,10);
                                var r = hex % 256;
                                var g = (hex / 256) % 256;
                                var b = (hex / 65536) % 256;

                                $element.find(".eve-values").empty().css("background-color",bigh.rgb2hex(r,g,b));
                            }
                            else if($element.attr("eve-manager-component") == "slider"){

                                $element.find(".eve-values").text(Math.round(parseFloat(resp.value)*100)+"%");
                            }
                            else if($element.attr("eve-manager-component") == "info"){
                            	
                            	resp.value = resp.value.trim();
                            	
                            	var spaceIndex = resp.value.indexOf(" ");
                            	if(spaceIndex == -1)
                            		$element.find(".eve-values").text(resp.value);
                            	else {
									var val = resp.value.substring(0,resp.value.indexOf(" "));
									var scale = resp.value.substring(resp.value.indexOf(" ")+1);
	                                $element.find(".eve-values").text(parseFloat(val).toFixed(2).replace(".00", "") + " " + scale);                           		
                            	}
                            	//$element.find(".eve-values").text(resp.value);
                            }
                            //Other component
                            else{
                              //  $element.find(".eve-values").text(resp.value);
                            }
                        };
                    }
                    //Disconnected
                    else{


                        //Graphic effect
                        /*
                        setTimeout(function(){
                            var $img = $("<img src='./assets/img/disconnected.png' height='160' width='160' style='position: absolute; bottom: 50px; right: 50px; font-size: 32px; background-color: #222; color: yellow; padding: 30px; border-radius: 30px; opacity: 1; display: block;' />");
                            $("body").append($img);
                            $img.animate({ opacity:.9 },200).animate({ opacity: 0 },{
                                duration: 200,
                                complete: function(){
                                    $img.remove();
                                }
                            });
                        },1);
                        */

                        $("#createcomponents [eve-manager-component] .eve-values").hide();

                        //Disable menu
                        $("[eve-manager-mainmenu='projectmenu']").find("[eve-manager-menu='connect']").removeClass("ui-state-disabled");
                        $("[eve-manager-mainmenu='projectmenu']").find("[eve-manager-menu='disconnect']").addClass("ui-state-disabled");

                        QT.updateParameter = function(resp){};
                    }
                },
                Parameter: function(e,key){
                    console.debug(e.type);

                    //Switch parameter
                    switch(key){
                        case "connectedUser":
                            //Check user permissions
                            var oUser = model["connectedUser"].getData();
                            var oPermissions = oUser.getPermissions();
                            //console.error(oPermissions);

                            //Reset all view
                            var $tabs = $("#tabs");
                            $("#interface").css("visibility","visible");
                            $("#createcomponents").css("visibility","visible");
                            $("#gateways").css("visibility","visible");

                            $tabs.tabs( "enable" );
                            $("[eve-manager-menu='user']").removeClass("ui-state-disabled");
                            $("[eve-manager-menu='users-new']").removeClass("ui-state-disabled");
                            $("[eve-manager-menu='upload']").removeClass("ui-state-disabled");
                            $("[eve-manager-mainmenu='tools']").removeClass("ui-state-disabled");
                            $("[eve-manager-mainmenu='toolsmenu']").removeClass("ui-state-disabled");
                            $("[eve-manager-menu='interface']").removeClass("ui-state-disabled");

                            //Create users
                            /*if(oPermissions[0] == undefined){
                                $("[eve-manager-menu='users-new']").addClass("ui-state-disabled");
                            }*/

                            //Manage users
                            if(oPermissions[1] == undefined){
                                $("[eve-manager-menu='users-new']").addClass("ui-state-disabled");
                                $("[eve-manager-menu='user']").addClass("ui-state-disabled");
                            }

                            //Manage Gateways
                            if(oPermissions[10] == undefined){
                                $tabs.tabs( "disable", 2);
                                $("#gateways").css("visibility","hidden");
                            }

                            //Manage Components
                            if(oPermissions[11] == undefined){
                                $tabs.tabs("disable", 1);
                                $("#createcomponents").css("visibility","hidden");
                                $("[eve-manager-mainmenu='tools']").addClass("ui-state-disabled");
                                $("[eve-manager-mainmenu='toolsmenu']").addClass("ui-state-disabled");
                                $("[eve-manager-menu='upload']").addClass("ui-state-disabled");
                            }

                            //Manage Interface
                            if(oPermissions[12] == undefined){
                                $tabs.tabs("disable", 0);
                                $("#interface").css("visibility","hidden");
                            }

                            //Manage Maps
                            if(oPermissions[13] == undefined){
                                $("[eve-manager-menu='interface']").addClass("ui-state-disabled");
                                $("#interface").css("visibility","hidden");
                            }

                            //Use Eve Manager
                            /*if(oPermissions[20] == undefined){
                                //Show message
                                var txt = _D("User") +" <span style='color:lightskyblue;'>"+ model["connectedUser"].getData().name + "</span> " + _D(" can't use") +" "+ presenter.preferences.getApplicationPreference("name");

                                //Close Eve Manager
                                $("#alert").dialog("option","modal",true);
                                $("#alert").on("dialogclose",QT.exit);

                                $document.trigger("app/warning",[txt]);
                            }*/

                            //Use Eve Remote
                            /*if(oPermissions[21] == undefined){
                                //console.log(oPermissions[10]);
                            }*/

                            //Use Plugins
                            /*if(oPermissions[30] == undefined){
                                //console.log(oPermissions[10]);
                            }*/

                            //No break
                        case "application":
                        case "currentProject":
                        case "currentUser":
                            var title = presenter.preferences.getApplicationPreference("name");

                            title += " - ";
                            title += "v"+ presenter.preferences.getApplicationPreference("version");
                            title += " - ";
                            title += _D("Connected user: ");
                            title += (presenter.preferences.getParameter("connectedUser") != undefined)?presenter.preferences.getParameter("connectedUser"):"n.d.";

                            title += " - ";
                            title += _D("Current user: ");
                            title += (presenter.preferences.getParameter("currentUser") != undefined)?presenter.preferences.getParameter("currentUser"):"n.d.";

                            title += " - ";
                            title += _D("Current project: ");
                            var prjName = (presenter.preferences.getParameter("currentProject") != undefined)?presenter.preferences.getParameter("currentProject")["projectName"]:"n.d.";
                            prjName = prjName.slice(0, (prjName.lastIndexOf(".eve") != -1)?prjName.lastIndexOf(".eve"):prjName.length );
                            title += prjName;

                            QT.setTitle(title);
                            break;
                        case "language":
                            //var languageId = application.getConfigParam(key);
                            var languageId = presenter.preferences.getParameter(key);
                            var $languageMenu = $("[eve-manager-mainmenu='languagemenu']");
                            $languageMenu.find("li .ui-icon").css("visibility","hidden");

                            //Check current language
                            switch(languageId){
                                case "en":
                                    $languageMenu.find("[eve-manager-menu='english'] .ui-icon").css("visibility","visible");
                                    break;
                                case "it":
                                    $languageMenu.find("[eve-manager-menu='italian'] .ui-icon").css("visibility","visible");
                                    break;
                                case "fr":

                                    $languageMenu.find("[eve-manager-menu='french'] .ui-icon").css("visibility","visible");
                                    break;
                            }
                            
                            break;
                        case "recents":
                            //var aRecents = application.getConfigParam(key);
                            var aRecents = presenter.preferences.getParameter(key);
                            var $fileMenu = $("[eve-manager-mainmenu='filemenu']");
                            var $recentList = $fileMenu.find("[eve-manager-menu='recents'] > ul"); 
                            
                            //Enable/disable recent projects
                            if(aRecents.length < 1){
                                $fileMenu.find("[eve-manager-menu='recents']").addClass("ui-state-disabled");
                                break;
                            }
                            else{
                                $fileMenu.find("[eve-manager-menu='recents']").removeClass("ui-state-disabled");
                            }
                            
                            //Empty list
                            $recentList.empty();
                            
                            for(var i=0; i<aRecents.length; ++i){
                                var $li = $("<li></li>");
                                var $a = $("<a></a>");
                                var $icon = $("<span></span>");
                                var $text = $("<span></span>");
                                
                                $li.attr("eve-manager-menu","recentProject");
                                $li.data("applicationProject",aRecents[i]);
                                
                                $a.attr("href","#");
                                
                                $icon.addClass("ui-icon");
                                $icon.css("visibility","hidden");

                                //console.error(aRecents[i]);
                                $text.text(aRecents[i].projectPath);
                                //$text.attr("title",aRecents[i].projectPath);

                                $a.append($icon);
                                $a.append($text);
                                $li.append($a);
                                $recentList.append($li);
                            }
                            $fileMenu.menu( "refresh" );
                            break;
                        case "view":
                            var viewMode = presenter.preferences.getParameter(key);
                            var $viewMenu = $("[eve-manager-mainmenu='viewmenu']");
                            $viewMenu.find("ul li .ui-icon").css("visibility","hidden");

                            console.warn("DEPRECATED");
                            break;

                            //Check current view
                            switch(viewMode){
                                case "classic":
                                    //Menu
                                    $viewMenu.find("[eve-manager-menu='classic'] .ui-icon").css("visibility","visible");

                                    //Check if is loaded maps css
                                    if($("#interface-style").attr("href") == "./css/interface-levels.css"){
                                        break;
                                    }

                                    //Levels interface
                                    w2ui["interface"].hide("main",true);                            //Hide maps interface
                                    w2ui["interface"].hide("left",true);                            //Hide maps interface

                                    $("#interface-style").attr("href","./css/interface-levels.css");

                                    w2ui["interface"].set("main",{ type: "preview" });              //Switch main to preview
                                    w2ui["interface"].set("left",{ type: "main" });                 //Switch left to main

                                    w2ui["interface"].refresh('main');
                                    w2ui["interface"].show("main",true);                            //Hide maps interface
                                    break;
                                case "maps":
                                    //Menu
                                    $viewMenu.find("[eve-manager-menu='maps'] .ui-icon").css("visibility","visible");

                                    //Check if is loaded maps css
                                    if($("#interface-style").attr("href") == "./css/interface-maps.css"){
                                        break;
                                    }

                                    //Maps interface
                                    w2ui["interface"].hide("main",true);                            //Hide maps interface

                                    $("#interface-style").attr("href","./css/interface-maps.css");

                                    w2ui["interface"].set("main",{ type: "left" });                 //Switch left to main
                                    w2ui["interface"].set("preview",{ type: "main" });              //Switch preview to main

                                    w2ui["interface"].refresh('left');
                                    w2ui["interface"].refresh('main');
                                    $("#interface-maps .maps-container").tabs({
                                        active: false
                                    });
                                    w2ui["interface"].show("main",true);                            //Show maps interface
                                    w2ui["interface"].show("left",true);                            //Show maps interface

                                    //Set toolbar labels from dictionary
                                    var $toolbar = $("#interface-maps .map-tools");
                                    var $dictionary = $toolbar.find("[dictionary]");
                                    var $dictionaryTitles = $toolbar.find("[dictionary-title]");

                                    //Set words
                                    for(var i=0; i<$dictionary.length; ++i){
                                        var $current = $($dictionary[i]);
                                        $current.text(application.Dictionary.getName($current.attr("dictionary")));
                                    }

                                    //Set titles
                                    for(var i=0; i<$dictionaryTitles.length; ++i){
                                        var $current = $($dictionaryTitles[i]);
                                        $current.attr("title",application.Dictionary.getName($current.attr("dictionary-title")));
                                    }

                                    $toolbar.find("button").button();

                                    //Select first UIComponent
                                    var oRoot = model["instance"].getUIComponentsRoot();
                                    application.selectUIComponent(oRoot.children[0]);
                                    break;
                            }

                            break;
                    }
                },
                Icons: function(e,key){
                    console.debug(e.type);
                    
                    var $iconsSet = $("#interface-icons, #lists-icons");
                    var $iconsForPicker = $("#interface-icons");
                    //var $iconsSet = $("#interface-icons");
                    //var $iconsSet2 = $("#lists-icons");

                    //Create icons accordion
                    $iconsSet.accordion("refresh");

                    var $allIcons = $iconsSet.find(".icons-all ul");

                    var $getIcons = $iconsSet.find("div:not(.icons-all) li");

                    //Create all icons
                    $allIcons.empty();
                    $allIcons.append($getIcons.clone(true));
                    
                    //Draw icons in icons picker
                    $(".pans-selector").empty();
                    $("#icons-picker").find(".pans-container").empty().append($iconsForPicker.find("div:not(.icons-all) ul").clone(true));
                    var $lists = $("#icons-picker").find(".pans-container ul");
                    //--console.log($lists);
                    for(var i=0; i<$lists.length; ++i){
                        var id = $( $lists[i] ).attr("application-pan-id");
                        var $option = $("<option>"+ $($lists[i]).attr("application-pan-name") +"</option>");
                        $option.val(id);
                        $(".pans-selector").append($option);
                    }

                    $lists.hide();

                    //Create draggable elements
                    //var strInterfaceElementSelector = "#interface-elements #interface-icons li";
                    //var strConnectWith = "#myinterface .level";
                    var strConnectWith = "#myinterface .level, #mylists  .level";

                    //$(strInterfaceElementSelector).css("border","solid 1px red");
                    //$(strInterfaceElementSelector).draggable({
                    $iconsSet.find("[application-pan-id]").draggable({
                        distance: 50,
                        appendTo: "body",
                        containment: "body",
                        revert: "invalid",
                        revertDuration: false,
                        connectToSortable: strConnectWith,
                        helper: "clone",
                        zIndex: 10000
                    });
                }
            }
        },
        Resize:{
            Window: function(e){
                console.debug("%c"+ e.type,"color:grey");
                
                var $window = $(window);
                var $tabs = $("#tabs");
                //var $panels = $("#interface, #createcomponents, #gateways, #relations");
                
                // Set tabs heigth (tab's top position - tab's thickness * 0.5)
                //$tabs.height(($window.height() - $tabs.offset().top) - (($tabs.outerHeight(true) - $tabs.height())*0.5 ));
                $tabs.height(($window.height() - $tabs.offset().top) - (($tabs.outerHeight(true) - $tabs.height())));
                
                // Set panels height
                //$panels.height($tabs.height() - ($panels.offset().top - $tabs.offset().top + parseInt($panels.css("padding"),10)));
                
                // Publish resize events
                $.publish("/view/interface/resize");
                $.publish("/view/relations/resize");
                $.publish("/view/components/resize");
                $.publish("/view/gateways/resize");
            },
            Interface: function(e){
                console.debug("%c"+ e.type,"color:grey");

                var $tabs = $("#tabs");
                var $interface = $("#interface");
                var $interfaceElements = $("#interface-elements").find(".ui-tabs-panel");
                var $interfaceMaps = $interface.find("#interface-maps");
                var $mapToolBar = $interface.find(".map-tools");
                var $mapContainer = $interface.find(".maps-container");

                // Check visibility
                if(!$interface.is(":visible")){
                    return;
                }

                // Set panel height
                $interface.height($tabs.height() - ($interface.offset().top - $tabs.offset().top + parseInt($interface.css("padding"),10)));
                w2ui['interface'].resize();

                // Set library height
                //$interfaceElements.height($tabs.height() - ($interfaceElements.offset().top - $tabs.offset().top + parseInt($interfaceElements.css("padding"),10)));
                //w2ui['interface'].resize();
                $("#interface-elements").tabs("refresh");

                //Resize also maps
                $.publish("/view/interface/maps/resize");

                // move component list inside map

            },
            Lists: function(e){
                console.debug("%c"+ e.type,"color:grey");

                var $tabs = $("#tabs");
                var $interface = $("#lists");
                /*var $interfaceElements = $("#lists-elements").find(".ui-tabs-panel");
                var $interfaceMaps = $interface.find("#interface-maps");
                var $mapToolBar = $interface.find(".map-tools");
                var $mapContainer = $interface.find(".maps-container");*/

                // Check visibility
                if(!$interface.is(":visible")){
                    return;
                }

                // Set panel height
                $interface.height($tabs.height() - ($interface.offset().top - $tabs.offset().top + parseInt($interface.css("padding"),10)));
                w2ui['lists'].resize();

                // Set library height
                //$interfaceElements.height($tabs.height() - ($interfaceElements.offset().top - $tabs.offset().top + parseInt($interfaceElements.css("padding"),10)));
                //w2ui['interface'].resize();
                $("#lists-elements").tabs("refresh");

                //Resize also maps
                //$.publish("/view/interface/maps/resize");
            },
            Components: function(e){
               // console.debug("%c"+ e.type,"color:grey");
                
                var $tabs = $("#tabs");
                var $createcomponents = $("#createcomponents");
                var $componentslibrary = $("#componentslibrary");
                var $mycomponents = $("#mycomponents");
                var $componentproperties = $("#componentproperties");
                
                // Check visibility
                if(!$createcomponents.is(":visible")){
                    return;
                }
                
                // Set panel height
                $createcomponents.height($tabs.height() - ($createcomponents.offset().top - $tabs.offset().top + parseInt($createcomponents.css("padding"),10)));
                w2ui['createcomponents'].resize();
                
                // Components library container
                $componentslibrary.find(" > .container").height($createcomponents.height() - ($componentslibrary.find(" > .container").offset().top - $createcomponents.offset().top));
                
                // My components container
                $mycomponents.find(" > .container").height($createcomponents.height() - ($mycomponents.find(" > .container").offset().top - $createcomponents.offset().top));
                
                // Components properties container
                $componentproperties.find(" > .container").height($createcomponents.height() - ($componentproperties.find(" > .container").offset().top - $createcomponents.offset().top));
            },
            Relations: function(e){
                console.debug("%c"+ e.type,"color:grey");

                var $tabs = $("#tabs");
                var $gateways = $("#relations");
                var $mygateways = $("#myrelations");
                var $relationComponents = $("#relations-components");

                // Set panel height
                $gateways.height($tabs.height() - ($gateways.offset().top - $tabs.offset().top + parseInt($gateways.css("padding"),10)));
                w2ui['relations'].resize();

                // Components library container
                $mygateways.find(" > .relations-container").height($gateways.height() - ($mygateways.find(" > .relations-container").offset().top - $gateways.offset().top));

                // Components properties container
                $relationComponents.find(" > .container").height($gateways.height() - ($relationComponents.find(" > .container").offset().top - $gateways.offset().top));
            },
            Gateways: function(e){
                //return;
                console.debug("%c"+ e.type,"color:grey");
                
                var $tabs = $("#tabs");
                var $gateways = $("#gateways");
                var $mygateways = $("#mygateways");
                
                // Set panel height
                $gateways.height($tabs.height() - ($gateways.offset().top - $tabs.offset().top + parseInt($gateways.css("padding"),10)));
                w2ui['gateways'].resize();
                
                // Components library container
                $mygateways.find(" > .container").height($gateways.height() - ($mygateways.find(" > .container").offset().top - $gateways.offset().top));
                //$("#gateways .gateways").height($("#tabs").height() - 65);
            },
            Maps: function(e){
                console.debug("%c"+ e.type,"color:grey");
                
                var $tabs = $("#tabs");
                var $interface = $("#interface");
                var $interfaceMaps = $interface.find("#interface-maps");
                var $mapToolBar = $interface.find(".map-tools");
                var $mapContainer = $interface.find(".maps-container");
                var $tabPanels = $mapContainer.find(".ui-tabs-panel");
                var $tabHeader = $mapContainer.find("> ul");
                
                // Check visibility
                if(!$interfaceMaps.is(":visible")){
                    return;
                }
                
                $mapContainer.height( $interface.height() - ($mapContainer.offset().top - $interface.offset().top + parseInt($mapContainer.css("padding"),10)) - parseInt($mapToolBar.css("height")) );

                //alert($mapToolBar.height());
                //$tabPanels.height( $mapContainer.height() - $tabHeader.outerHeight() - (parseInt($tabPanels.css("padding"),10)*2) - parseInt($mapToolBar.css("height")) );
                $tabPanels.height( $mapContainer.height() - $tabHeader.outerHeight() - (parseInt($tabPanels.css("padding"),10)*2) );
            }
        }
    }
};


//TEMPORARY FUNCTION (enable/disable debug)
console.debug = function(arg){
    //console.log("%c"+ arg, "color:blue;");
};