/** Javascript Aernova Wizard TU01 TU02 Importer
 *
 * 28/8/2015 by Andreosky Padovanosky
 *
 */
"use strict";

var VERSION = "v.1.0.0";
var NAME = "Aernova TU01 TU02 Wizard " + VERSION;
var $ = jQuery;


try {
    console.log("%cStart " + NAME, "color:DarkSlateBlue");
    create_gui();
    console.log("%cEnd " + NAME, "color:DarkSlateBlue");
} catch (err) {
    console.error(NAME + " error\n" + err);
    alert(NAME + " error\n" + err);
}


function create_gui() {
    var wizard = $("<div id='aernova-wizard' title='" + NAME + "'></div>");
    wizard.append("</br><label>Name</label></br>");
    wizard.append("<input type='text' id='gtw-name' value='Aernova TU01-TU02'/></br>");
    wizard.append("</br><label>Address</label></br>");
    wizard.append("<input type='text' id='gtw-address' value='192.168.1.250'/></br>");
    wizard.append("</br><label>Port</label></br>");
    wizard.append("<input type='text' id='gtw-port' value='502' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><label>Numbers of zones</label></br>");
    wizard.append("<input type='text' id='zones-count' value='10' onkeypress='bigh.onlyPosInt();' /></br>");
    $("body").append(wizard);

    wizard.dialog({
        modal: true,
        width: 350,
        close: function () {
            $(this).remove();
        },
        buttons: {
            "Create Componens...": function () {
                $(this).dialog("close");
                $(this).remove();

                blr.executionStack.show(NAME);
                main(
                    $(this).children("#gtw-name").val(),
                    $(this).children("#gtw-address").val(),
                    $(this).children("#gtw-port").val(),
                    $(this).children("#zones-count").val()
                );
            },
            Cancel: function () {
                $(this).dialog("close");
                $(this).remove();
            }
        }
    });

    return wizard;
}

function main(name, ip, port, zonesCount) {
    try {
        var oGateway = getGateway(name, ip, port);
        var oGroup = getMainGroup(name);

        for (var i = 0; i < zonesCount; ++i) {
            var zoneID = i+1;
            blr.executionStack.push(
                function (in_args, out_args) {
                    out_args = create_device(in_args.gateway, in_args.group, in_args.slaveID, in_args.zoneID);
                },
                {
                    gateway: oGateway,
                    group: oGroup,
                    slaveID: zoneID,
                    zoneID: zoneID
                }
            );
        }

        blr.executionStack.execute(100, true);
    } catch (err) {
        console.error(NAME + " error\n" + err);
        alert(NAME + " error\n" + err);
    }
}

function create_device(gateway, group, slaveID, zoneID) {
    var oItem = null;
    var oGroup = application.addComponent({
        type: "group",
        name: _D("Zone") + " " + zoneID
    }, group);



    return oGroup;
}


function getGateway(name, address, port) {
    var oGateway = undefined;

    if (oGateway == undefined) {
        oGateway = application.addGateway({
            name: name,
            protocol: "modbusrtutcp"
        });
    }
    oGateway.data.setName(name);
    oGateway.data.setParamVal("modbusrtutcp/address", address);
    oGateway.data.setParamVal("modbusrtutcp/port", port);
    oGateway.data.setParamVal("modbusrtutcp/asciitransform", false);
    oGateway.data.setParamVal("modbusrtutcp/readinterval", 250);
    oGateway.data.setParamVal("modbusrtutcp/timeout", 150);

    return oGateway;
}

function getMainGroup(name) {
    var oGroup = application.addComponent({
        type: "group",
        name: name
    });
    return oGroup;
}
